#include	<ext.h>
#include	<stdarg.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>
#include	<math.h>
#include	<x_gem.h>
#include	"mypdf.h"
#include	"mypdf.rh"
#include	"files.h"
#include	"typespdf.h"
#include	"info_pdf.h"
#include	"status.h"
#include	"options.h"
#include	"mp_const.h"
#include	"memdebug.h"
#include	"av_comm.h"
#include	"filters.h"
#include	"graf_sta.h"
#include	"cont_pat.h"
#include	"text_st.h"
#include	"page_con.h"
#include	"windinfo.h"
#include	"sys_pal.h"



#define ULONG		unsigned long

void Init_statistics(void);
void Update_statisticks(char *name, BOOLEAN in);
void Exit_statistics(void);

void Display_page (WIND_LIST *wind);

void Store_gfx_state(void);
void Restore_gfx_state(void);
void Check_gfx_state(void);

void ani_mouse (void);
void Change_progress_bar (int status, int window, unsigned long value, unsigned long max_value);

int Decompress_stream(struct filter *input, int window);

void Load_font_object(struct PDF_Info *pdf_info);
struct fonts *SetFont (WIND_LIST *wind, char *name, struct page_resource *resource);
void Load_annotations(struct PDF_Info *info, struct PDF_PageTree *page_tree);

char *Read_line (struct files_pdf *file);
int Command2ID(struct files_pdf *file, char **table);

struct PDF_PageTree *find_page_tree(struct PDF_Info *info, struct PDF_PageTree *, int page_no, int max);
struct Page_tree *read_Page_tree(struct files_pdf *file, long *obj);
int read_filter(struct files_pdf *file, char *table);

unsigned long Read_object_no(struct files_pdf *file);

BOOLEAN GoToObject(struct PDF_Info *info, unsigned int obj);
BOOLEAN GoBack(struct PDF_Info *info);
void GoToPage(struct PDF_Info *pdf_info, int page_no);

struct page_resource *read_page_resources(struct PDF_Info *info, unsigned int obj);
void Free_Page_Contents(struct page_contents *);

short FindColorByRGB (short *table, short mode);
void CMYK2RGB (short *table_in, short *table_out);

void Display_text(int handle, int x, int y, OB_Tj *Tj, BOOLEAN TJ, struct PDF_Info*);

BOOLEAN read_text(char *source, char *destination, int *len_in, int *len_out, int font_type, BOOLEAN TJ, struct fonts *);

BOOLEAN Load_cache(WIND_INFO *wind_info);
BOOLEAN Save_cache(WIND_INFO *wind_info);


static struct graphical_state act_graf_state, *base_graf_state;


extern X_GEM_INFO *x_gem;
extern WIND_LIST windows[];
extern struct opt options;
extern OBJECT *adr_doc_info;

extern struct fonts *base_font;

extern char *types_command[];


struct picture *pict_dummy;

struct picture *Load_picture(struct PDF_Info *, char *name);
struct picture *Add_picture(struct picture *, struct picture *source);
struct picture *Find_picture(struct picture *, char *name);
void Display_picture(int window, int pos_x, int pos_y, OB_Picture *, struct PDF_Info *);

int draw_path (short handle, short mode, struct graphical_state *path, struct path_objects *objects, unsigned long max_obj, short offset_x, short offset_y, short page_h, double scale);

void add_pdf_object (WIND_LIST *wind, short type, ...);
void clear_all_pdf_objects (WIND_LIST *wind);



#define MAX_OBJECTS	20000L

#define CONTENTS_COMM_LENGTH	1
#define CONTENTS_COMM_FILTER	2
#define CONTENTS_COMM_STREAM	3

char *contents_command[]={
		"/Length",
		"/Filter",
		"stream",
		NULL};


struct Text_State text_state;									/* This is the main variable needed by text positioning!!	*/

struct _stream_command
	{
	char *name;
	int param;																	/* How many digits should be given as a parameter		*/
	int calls;
	int pos;
	char type;
	}stream_command[]={
				/* Text painting and state operators	*/
	"Tc", 1, 0, 0, 0,
	"Tw", 1, 0, 0, 0,
	"Tz", 1, 0, 0, 0,
	"TL", 1, 0, 0, 0,
	"Tf", 2, 0, 0, 0,					/* Najpierw nazwa z '/' a potem cyfra	*/
	"Tr", 1, 0, 0, 0,
	"Ts", 1, 0, 0, 0,
	"Th", 1, 0, 0, 0,
	"Tj", -1, 0, 0, 0,
	"TJ", -1, 0, 0, 0,
	"Td", 2, 0, 0, 0,
	"TD", 2, 0, 0, 0,
	"Tm", 6, 0, 0, 0,
	"T*", 0, 0, 0, 0,
	"'", 0, 0, 0, 0,
	"\"", 0, 0, 0, 0,
	"BT", 0, 0, 0, 0,
	"ET", 0, 0, 0, 0,
				/* Path construction commands. Starts with 19 and ends with 25	*/
	"m", 2, 0, 0, 0,
	"l", 2, 0, 0, 0,
	"c", 3, 0, 0, 0,
	"v", 2, 0, 0, 0,
	"y", 2, 0, 0, 0,
	"h", 0, 0, 0, 0,
	"re", 4, 0, 0, 0,
				/* Path painting. Starts with 26 and ends with 37	*/
	"S", 0, 0, 0, 0,
	"s", 0, 0, 0, 0,
	"f", 0, 0, 0, 0,
	"F", 0, 0, 0, 0,
	"f*", 0, 0, 0, 0,
	"B", 0, 0, 0, 0,
	"B*", 0, 0, 0, 0,
	"b", 0, 0, 0, 0,
	"b*", 0, 0, 0, 0,
	"n", 0, 0, 0, 0,
	"W", 0, 0, 0, 0,
	"W*", 0, 0, 0, 0,
				/* Object positioning and pictures (38-38)	*/
	"Do", 1, 0, 0, 0,
				/* Text state operators (39-46)							*/
	"rg", 3, 0, 0, 0,
	"RG", 3, 0, 0, 0,
	"k", 4, 0, 0, 0,
	"K", 4, 0, 0, 0,
	"SC", 3, 0, 0, 0,
	"sc", 3, 0, 0, 0,
	"g", 1, 0, 0, 0,
	"G", 1, 0, 0, 0,
				/* Graphics state operators (47-58)					*/
	"q", 0, 0, 0, 0,
	"Q", 0, 0, 0, 0,
	"cm", 6, 0, 0, 0,
	"W", 1, 0, 0, 0,
	"w", 1, 0, 0, 0,
	"J", 1, 0, 0, 0,
	"j", 1, 0, 0, 0,
	"M", 1, 0, 0, 0,
	"d", 2, 0, 0, 0,
	"ri", 1, 0, 0, 0,
	"i", 1, 0, 0, 0,
	"gs", 1, 0, 0, 0,
				/* Unimplemented commands	(59-64)									*/
	"BX", 0, 0, 0, 0,
	"EX", 0, 0, 0, 0,
	"cs", 1, 0, 0, 0,
	"CS", 1, 0, 0, 0,
	"scn", 3, 0, 0, 0,
	"SCN", 3, 0, 0, 0,
	NULL, 0, 0, 0, 0};




/* ******************************** */


static unsigned long line_length;

#define MAX_TEXT_POS	500
#define SET_TEXT	{	strncpy(text, &stream[*stream_pos], strcspn(&stream[*stream_pos], "\r\n"));	\
										if(text[strlen(text)-1]==' ')	\
												text[strlen(text)-1]=0;	}
#define CLEAR_TEXT	{	strnset(text, 0, MAX_TEXT_POS);	}


static unsigned long prev_pos_stream;


size_t  strlen1( const char *s )
	{
	if(s!=NULL)
		return(strlen(s));
	else
		return(-1);
	}


void Check_ending2(char **stream)
	{
	if(*stream!=NULL)
		{
		if(strlen1(*stream)>0)
			{
			if(**stream=='\n' || **stream=='\r')
				(*stream)++;
			if(**stream=='\n' || **stream=='\r')
				(*stream)++;

			if((**stream==' ' && *(*stream+1)=='\r') || (**stream==' ' && *(*stream+1)=='\n'))
				{
				(*stream)++;
				if(**stream=='\n' || **stream=='\r')
					(*stream)++;
				if(**stream=='\n' || **stream=='\r')
					(*stream)++;
				}
			}
		}
	}


short read_contents_command (char **stream, unsigned long max_len, int digits)
	{
	char text[MAX_TEXT_POS]={0};
	short i;
	unsigned long output=0, output_pos=MAX_TEXT_POS;

#ifdef STAT
	Update_statisticks("read_contents_command", 1);
#endif

	if(*stream==NULL)
		return(-1);
	if(strlen1(*stream)==0)
		return(-1);

	Check_ending2(stream);
	if(strlen1(*stream)==0)
		return(-1);


	if (**stream!='/' && isalpha(**stream)==0 && isdigit(**stream)==0 && **stream!=' ' && **stream!='-' && **stream!='[' && **stream!='(' && **stream!='<')
		{
#ifdef STAT
	Update_statisticks("read_contents_command", 0);
#endif
		return (-1);
		}


	prev_pos_stream = (unsigned long)(*stream);


	Check_ending2(stream);

	strncpy(text, *stream, strcspn(*stream, "\r\n"));
	if(text[strlen1(text)-1]==' ')
		text[strlen1(text)-1]=0;


/* **************************************************************** */
/* First we have to check if this is not "TJ", "Tj" or " d" command	*/

	if(text[0]=='[')
		{
		line_length = strlen1(text);

		Check_ending2((char**)(*stream + line_length));

		if(strstr(text, "]TJ"))
			{
#ifdef STAT
	Update_statisticks("read_contents_command", 0);
#endif
			stream_command[TEXT_OPERATORS+9-1].calls++;
			return(TEXT_OPERATORS+9);
			}
		else
			{
#ifdef STAT
	Update_statisticks("read_contents_command", 0);
#endif
			stream_command[GRAPHIC_STATE_OPERATOR+7-1].calls++;
			return (GRAPHIC_STATE_OPERATOR+7);
			}
		}

	if(text[0]=='(' || text[0]=='<')
		{
		line_length = strlen1(text);

		Check_ending2((char**)(*stream + line_length));

#ifdef STAT
	Update_statisticks("read_contents_command", 0);
#endif
		stream_command[9-1].calls++;
		return(9);
		}

/* **************************************************************** */



/* If the command has 0 parameters then we are at the beginning of the command */
/*	if(digits==0)	*/
		{
		for(i=0; stream_command[i].name!=NULL; i++) 
			{
			if(digits==stream_command[i].param && strncmp(text, stream_command[i].name, strcspn(text, "\r\n ([<"))==0)
				{
				*stream += strlen(stream_command[i].name);
				stream_command[i].calls++;
#ifdef STAT
	Update_statisticks("read_contents_command", 0);
#endif	
				return(i+1);
				}
			}
		}

	while(**stream!='\n')
		{
		if(**stream==' ' || **stream=='\r')
			break;
		else
			(*stream)++;
		}
	return(1000);
	}





signed long read_number(char *stream, unsigned long *len)
	{
	signed long output=0;

	if(stream==NULL || stream[0]==0x0)
		return(-1);

	output = (signed long)((double)1000*atof(stream));

	if(len!=NULL)
		(*len) = strspn(stream, "-+0123456789.");

	return(output);
	}



double Get_Scale(int page_w, int page_h, int win_w, int win_h, int mode)
	{
	double output;

	switch (mode)
		{
		case ZOOM_100:										/* full page (1:1) */
			output = 1;
		break;
		case ZOOM_FULLPAGE:									/* page height */
			output = (double)win_h / (double)page_h;
		break;
		case ZOOM_PAGEWIDTH:								/* page width */
			output = (double)win_w / (double)page_w;
		break;
		case ZOOM_CUSTOM:
			if (page_w > page_h)
				output = (double)win_w / (double)page_w;
			else
				output = (double)win_h / (double)page_h;
		break;
		}	

	return(output);
	}




double Change_scale(short window, struct PDF_Info *pdf_info, unsigned long *page_w, unsigned long *page_h, unsigned long *offset_x, unsigned long *offset_y,
										int *win_x, int *win_y, int *win_w, int *win_h, WIND_LIST *wind1)
	{
	WIND_LIST *wind=NULL;
	struct PDF_PageTree *page = find_page_tree(pdf_info, NULL, (int)pdf_info->page_no, 1);		/* The actual page */
	struct PDF_PageTree *page_temp=NULL;
	double scale=0;

	wind = &windows[window];																	/* Window */

	if(wind1==NULL)
		{
		*win_x = wind->w_work_wind.g_x;
		*win_y = wind->w_work_wind.g_y;
		*win_w = wind->w_work_wind.g_w;
		*win_h = wind->w_work_wind.g_h;
		}
	else
		{
		*win_x = wind1->w_work_wind.g_x;
		*win_y = wind1->w_work_wind.g_y;
		*win_w = wind1->w_work_wind.g_w;
		*win_h = wind1->w_work_wind.g_h;
		}

	if (page->MediaBox.x2 != 0)
		*page_w = page->MediaBox.x2;
	else
		{
		page_temp = find_page_tree (pdf_info, NULL, 1, 1);
		*page_w = page_temp->MediaBox.x2;
		}

	if (page->MediaBox.y2 != 0)
		{
		*page_h = page->MediaBox.y2;
		text_state.pos_y = page->MediaBox.y2 * 1000;
		}
	else
		{
		page_temp = find_page_tree (pdf_info, NULL, 1, 1);
		*page_h = page_temp->MediaBox.y2;
		text_state.pos_y = page->MediaBox.y2 * 1000;
		}

	*offset_y = *win_y;

	scale = Get_Scale((int)*page_w, (int)*page_h, *win_w, *win_h, ZOOM_FULLPAGE);
	switch (pdf_info->zoom)
	{
		case ZOOM_100:										/* full page (1:1) */
			scale = 1;
			*page_w = (unsigned long)(scale * (double)*page_w);
			*page_h = (unsigned long)(scale * (double)*page_h);
		break;
		case ZOOM_FULLPAGE:									/* page height */
			*page_w = (unsigned long)(scale * (double)*page_w);
			*page_h = *win_h;
		break;
		case ZOOM_PAGEWIDTH:								/* page width */
			scale = Get_Scale((int)*page_w, (int)*page_h, *win_w, *win_h, ZOOM_PAGEWIDTH);
/*			printf("* scale=%Ld,\npage_h=%d,\nwin_w=%d,\nwin_h=%d\n\n", (unsigned long)(scale*1000), (int)page_h, win_w, win_h);	*/
			*page_h = (unsigned long)(scale * (double)*page_h);
			*page_w = *win_w;
			*offset_x = *win_x;
		break;
		case ZOOM_CUSTOM:
			scale = Get_Scale((int)pdf_info->zoom_w, (int)pdf_info->zoom_h, *win_w, *win_h, ZOOM_CUSTOM);
			*offset_x = *win_x;
			*page_h = (unsigned long)(scale * (double)*page_h);
			*page_w = (unsigned long)(scale * (double)*page_w);
		break;

		case ZOOM_25:
			scale = 0.25;
			*page_w = (unsigned long)(scale * (double)*page_w);
			*page_h = (unsigned long)(scale * (double)*page_h);
		break;
		case ZOOM_50:
			scale = 0.5;
			*page_w = (unsigned long)(scale * (double)*page_w);
			*page_h = (unsigned long)(scale * (double)*page_h);
		break;
		case ZOOM_75:
			scale = 0.75;
			*page_w = (unsigned long)(scale * (double)*page_w);
			*page_h = (unsigned long)(scale * (double)*page_h);
		break;
		case ZOOM_125:
			scale = 1.25;
			*page_w = (unsigned long)(scale * (double)*page_w);
			*page_h = (unsigned long)(scale * (double)*page_h);
		break;
		case ZOOM_150:
			scale = 1.5;
			*page_w = (unsigned long)(scale * (double)*page_w);
			*page_h = (unsigned long)(scale * (double)*page_h);
		break;
		case ZOOM_200:
			scale = 2;
			*page_w = (unsigned long)(scale * (double)*page_w);
			*page_h = (unsigned long)(scale * (double)*page_h);
		break;
		case ZOOM_300:
			scale = 3;
			*page_w = (unsigned long)(scale * (double)*page_w);
			*page_h = (unsigned long)(scale * (double)*page_h);
		break;

		default:
/*			scale = (double)((double)tab_size[pdf_info->zoom - ZOOM_25] / (double)100);	*/
			*page_w = (unsigned long)(scale * (double)*page_w);
			*page_h = (unsigned long)(scale * (double)*page_h);
		break;
	}

	if (pdf_info->zoom == ZOOM_CUSTOM && pdf_info->zoom_x != 0 && pdf_info->zoom_y != 0)
		{
		wind->w_pos_x = pdf_info->zoom_x / x_gem->sys_font_width;
		wind->w_pos_y = pdf_info->zoom_y / x_gem->sys_font_height;
		pdf_info->zoom_x = 0;
		pdf_info->zoom_y = 0;
		}
	else
		{
		wind->w_pos_x = 0;
		wind->w_pos_y = 0;
		}

	wind->w_nb_col = *page_w;
	wind->w_nb_vcol = *win_w;

	wind->w_nb_lig = *page_h;
	wind->w_nb_vlig = *win_h;

	x_set_slider_wind (window, SET_HSLIDE|SET_VSLIDE|SET_HSLSIZE|SET_VSLSIZE);


	itoa ((int)(scale*(double)100), x_get_ob_text (wind->w_dial.d_addr, SIZE_TB), 10);
	strcat (x_get_ob_text (wind->w_dial.d_addr, SIZE_TB), "%");
	x_redraw_wind (x_gem->event_wind, DRAW_AES, SIZE_TB - 1, &x_gem->desk_size);

	pdf_info->scale = scale;
	return(scale);
	}





/*
		***************************************************************
	This is the main routine for displaying the page contents.
	We have to focus on this routine to display all needed informations 
	in a given format - this will be the hardest part, because of the
	very complex format....

	ER: now the routine store vdi instructions in structure and
		not display it directly.

		***************************************************************
*/

#define PREPARE_CONTENTS {	Check_ending2(&contents);		\
				digits_=0; \
				if(*contents==' ')		\
					contents++;		\
				if(*contents!='/' && *contents!='(' && *contents!='(' && *contents!='[' && *contents!='\r' && *contents!='\n')		\
					{		\
					while(isdigit(*contents)!=0 || *contents=='-')		\
						{		\
						digits[digits_++] = (signed long)(atof(contents)*1000);		\
						contents += strcspn(contents, " ");		\
						contents++;		\
						}		\
					while(*contents==' ')		\
						contents++;	\
					}		\
				if(*contents=='/')		\
					{		\
					memset(names, 0, 99);		\
					digits_++;		\
					strncpy(names, contents, strcspn(contents, " "));		\
					contents += strcspn(contents, " ");		\
					if(*contents==' ')		\
						contents++;		\
					if(*contents=='-' || isdigit(*contents)!=0)	{	\
						digits[digits_-1] = (int)(atof(contents)*1000);		\
					digits_++;		\
					contents += strcspn(contents, " ");		\
						contents++;		\
					while(*contents==' ')		\
						contents++;		}	}	}


void Init_display_page (short window, struct PDF_Info *pdf_info)
{
	char *output1=NULL;																				/* Help strings */
	int win_x=0, win_y=0, win_w=0, win_h=0;														/* Window coordinates */
	signed long text_w=12;
	short pxy_array[16] = {0};
	int con_str=0;																				/* Number of the content to proceed */
	unsigned long unpacked_length=0;
	unsigned long i=0, j=0;
	unsigned long num_len=0;
	char *dummy_output=NULL, *dummy_output2=NULL;
	signed long dummy_lenght=0;
	WIND_LIST *wind=NULL;
	short keep_going=TRUE, first_TD=TRUE;
	unsigned long done_objects=0;
	unsigned long offset_x=0, offset_y=0, page_w=0, page_h=0, how_many_pages=0, dx=0, dy=0;
	unsigned long aa=0,bb=0,cc=0,dd=0,ee=0,ff=0;
	unsigned long move_txt_x=0, move_txt_y=0;
	double scale=1;
	struct PDF_PageTree *page = find_page_tree(pdf_info, NULL, (int)pdf_info->page_no, 1);		/* The actual page */
	struct PDF_PageTree *page_temp=NULL;
	struct Page_tree *page_tree=NULL, page_tree1;
	struct	files_pdf		*file_info = pdf_info->file_info;
	struct filter input_stream;
	struct path_objects *objects=NULL;
	struct page_resource *resource=NULL;
	struct page_contents *page_content=NULL;
	struct fonts *current_font=NULL;
	char *contents=NULL;
	int digits_;
	signed long digits[10]={0};								/* Digits that are before any command	*/
	char names[100]={0};												/* Names that are before any command	*/

	output1 = (char*)malloc(5000);
	if(output1)
		memset(output1, 0, 5000);
	else
		return;

	if(base_graf_state!=NULL)
		free(base_graf_state);
	base_graf_state = NULL;				/* Let's init the graphic state	*/

#ifdef STAT
	Init_statistics();
	Update_statisticks("Init_display_page", 1);
#endif
	prev_pos_stream = 0;


/*
	THIS PART SHOULD BE PLACED SOMEWHERE ELSE
	FOR EXAMPLE IN PAGETREE.C!!
	-----------------------------------------
	if(page->Annots && page->annots==NULL)
		{
		Change_progress_bar (STATUS_PDF_LINK_ANNOTS, window, -1, -1);
		Load_annotations(pdf_info, page);
		}
*/

		/* Standard things for path	*/

	act_graf_state.line_width = 1000L;
	act_graf_state.line_type = 1;
	act_graf_state.line_color = BLACK;
	act_graf_state.fill_color = BLACK;

	text_state.pos_x = (unsigned long)win_x * 1000UL;
	text_state.pos_y = (unsigned long)win_y * 1000UL;
	text_state.rotate = 0;
	text_state.Tfs = 10;
	text_state.base_Tfs = 10000;
	text_state.color = BLACK;


/* ************	*/

	scale = Change_scale(window, pdf_info, &pdf_info->page_w, &pdf_info->page_h, &pdf_info->off_x, &pdf_info->off_y, &win_x, &win_y, &win_w, &win_h, NULL);

	if(page->Rotate==0 || page->Rotate==180)
		{
		page_w = pdf_info->page_w;
		page_h = pdf_info->page_h;
		}
	else if(page->Rotate==90 || page->Rotate==270)
		{
		page_w = pdf_info->page_h;
		page_h = pdf_info->page_w;
		}
	offset_x = pdf_info->off_x;
	offset_y = pdf_info->off_y;

/* **********	*/

	wind = &windows[window];

	offset_x = (unsigned long)(win_x + (win_w - (short)(scale * (double)page_w)) / 2);

	if (offset_x<win_x || offset_x>(win_x+win_w))
		if (page_temp != NULL)
			if (offset_x > (win_x + (short)(scale * (double)page_temp->MediaBox.x2)))
				offset_x = (unsigned long)win_x;

	pxy_array[0] = 0;
	pxy_array[1] = 0;
	pxy_array[2] = (short)page_w;
	pxy_array[3] = (short)page_h;

	add_pdf_object (wind, 0, pxy_array);					/* create a white page */

	if (page_content == NULL)
		page_content = calloc (1, sizeof (struct page_contents));


		/*	Now we have to read the page resources - TO DO!!!!	(Fonts, pictures, etc.)	*/

	pdf_info->file_info->actual_pos = page->Resources + 1;

	if (pdf_info->pages_contents[0].page_no != pdf_info->page_no && pdf_info->pages_contents[1].page_no != pdf_info->page_no && pdf_info->pages_contents[2].page_no!=pdf_info->page_no)
		{
		if (pdf_info->file_info->buffer[pdf_info->file_info->actual_pos]=='[' || pdf_info->file_info->buffer[pdf_info->file_info->actual_pos+1]=='[' || pdf_info->file_info->buffer[pdf_info->file_info->actual_pos+2]=='[')
			{
			page_content->resource = read_page_resources(pdf_info, (unsigned int)Read_object_no(pdf_info->file_info));
		/*	GoToObject(pdf_info, (unsigned int)Read_object_no(pdf_info->file_info));	*/
			}
		else
			page_content->resource = read_page_resources(pdf_info, (unsigned int)Read_object_no(pdf_info->file_info));
		}
	else
		{
		if (page_content!=NULL)
			free(page_content);
		if(pdf_info->pages_contents[0].page_no == pdf_info->page_no)
			page_content = pdf_info->pages_contents[0].adress;
		else if(pdf_info->pages_contents[1].page_no == pdf_info->page_no)
			page_content = pdf_info->pages_contents[1].adress;
		else
			page_content = pdf_info->pages_contents[2].adress;
		}

	resource = page_content->resource;

		/*	Now let's find the page contents	*/
	
	pdf_info->file_info->actual_pos = page->Contents+1;

	if (file_info->buffer[file_info->actual_pos]=='[' || file_info->buffer[file_info->actual_pos+1]=='[' || file_info->buffer[file_info->actual_pos+2]=='[')
	{
		page_tree = read_Page_tree(file_info, (long*)&how_many_pages);
	}
	else
	{
		page_tree = &page_tree1;
		page_tree->page_no = (int)Read_object_no(file_info);
		how_many_pages=1;
	}

	con_str=0;

	Change_progress_bar (STATUS_BAR1_UPDATE, window, 1, 4);

	if(Load_cache((WIND_INFO *)(wind->w_user1))==FALSE)
		{
		if (pdf_info->pages_contents[0].page_no!=pdf_info->page_no && pdf_info->pages_contents[1].page_no!=pdf_info->page_no && pdf_info->pages_contents[2].page_no!=pdf_info->page_no)
			{
			while (page_tree[con_str].page_no>0 && how_many_pages>0)							/* MAIN LOOP	*/
				{
				how_many_pages--;
				GoToObject(pdf_info, (unsigned int)page_tree[con_str].page_no);

				input_stream.input_len = input_stream.output_len = 0;
				input_stream.input = input_stream.output = NULL;
				input_stream.filter_table = NULL;

				while(keep_going!=0)
					{
					switch((keep_going=Command2ID(file_info, contents_command)))
						{
						case CONTENTS_COMM_LENGTH:
								j = Read_object_no(file_info);
								if(isdigit(file_info->buffer[file_info->actual_pos]) || isdigit(file_info->buffer[file_info->actual_pos+1]))
									{
									GoToObject(pdf_info, (unsigned int)j);
									Read_line(file_info);
									input_stream.input_len = Read_object_no(file_info);
									GoBack(pdf_info);
									}
								else
									input_stream.input_len = j;
								break;
						case CONTENTS_COMM_FILTER:
								input_stream.filter_table = calloc(10, 1);
								if(input_stream.filter_table==NULL)
									return;
								read_filter(file_info, input_stream.filter_table);
								break;
						case CONTENTS_COMM_STREAM:
								Read_line(file_info);
								input_stream.input = calloc(1, input_stream.input_len+100);
								if(input_stream.input)
								{
									memcpy(input_stream.input, &file_info->buffer[file_info->actual_pos], input_stream.input_len);
									keep_going=0;
									if(input_stream.filter_table!=NULL)
										{
										Decompress_stream(&input_stream, window);

										if(dummy_output!=NULL)
											{
											dummy_output2 = calloc(1, dummy_lenght+100);
											memcpy(dummy_output2, dummy_output, dummy_lenght);
											free(dummy_output);
											dummy_output = calloc(1, dummy_lenght+input_stream.output_len+100);

											memcpy(dummy_output, dummy_output2, dummy_lenght);
											memcpy(dummy_output+dummy_lenght, input_stream.output, input_stream.output_len);

											dummy_lenght += input_stream.output_len;
											free(dummy_output2);
											dummy_output2=NULL;
											}
										else
											{
											dummy_output = calloc(1, dummy_lenght+input_stream.output_len+100);
											dummy_lenght = input_stream.output_len;
											memcpy(dummy_output, input_stream.output, input_stream.output_len);
											}

										input_stream.output_len = 0;

										free(input_stream.output);
										free(input_stream.input);
										free(input_stream.filter_table);
										input_stream.input=NULL;
										input_stream.output=NULL;
										input_stream.filter_table = NULL;
										}
									else
										{
										input_stream.output = input_stream.input;
										input_stream.output_len = input_stream.input_len;
										}
									}
							else
								return;
							break;
							}
						}
				con_str++;
				keep_going=1;
				}
			if(page_tree!=&page_tree1)
				free(page_tree);

		if(dummy_output)
			{
			input_stream.output = dummy_output;
			input_stream.output_len = dummy_lenght;
			}
		(char*)page_content->content = input_stream.output;
		page_content->content_len = input_stream.output_len;
		}
	else
		{
		if(pdf_info->pages_contents[0].page_no == pdf_info->page_no)
			page_content = pdf_info->pages_contents[0].adress;
		else if(pdf_info->pages_contents[1].page_no == pdf_info->page_no)
			page_content = pdf_info->pages_contents[1].adress;
		else
			page_content = pdf_info->pages_contents[2].adress;
		input_stream.output = (char*)page_content->content;
		input_stream.output_len = page_content->content_len;
		}


		/* Here we will display the first contents stream !!!	*/
	if(input_stream.output)
		{
		objects = calloc(MAX_OBJECTS, sizeof(struct path_objects));

		if((struct page_contents *)pdf_info->pages_contents[2].adress && objects==NULL)
			{
			x_gem_alert("[4][~40Freeing 2-nd block][ [OK  ]", 0L);
			Free_Page_Contents((struct page_contents *)(pdf_info->pages_contents[2].adress));
			objects = calloc(MAX_OBJECTS, sizeof(struct path_objects));
			}
		if((struct page_contents *)pdf_info->pages_contents[1].adress && objects==NULL)
			{
			x_gem_alert("[4][~40Freeing 1-st block][ [OK  ]", 0L);
			Free_Page_Contents((struct page_contents *)(pdf_info->pages_contents[1].adress));
			objects = calloc(MAX_OBJECTS, sizeof(struct path_objects));
			}

		if(objects==NULL)
			{
			x_gem_alert("[4][~40System out of memory|~40while allocating|~24sizeof(struct path_objects)][ [OK  ]", 0L);
			return;
			}


		contents = input_stream.output;
		unpacked_length = 0;
		done_objects = 0;
		line_length = 0;

		Change_progress_bar (STATUS_BAR1_UPDATE, window, 2, 4);
		Change_progress_bar (STATUS_BAR3_UPDATE, window, 0, input_stream.output_len);
		Change_progress_bar (STATUS_PDF_RENDERING, window, 0, input_stream.output_len);

		while (((unsigned long)(contents-input_stream.output))<input_stream.output_len && keep_going!=-1 && strlen1(contents)>0 && done_objects<MAX_OBJECTS)
		{

			keep_going=1;
			Change_progress_bar (STATUS_BAR3_UPDATE, window, (unsigned long)(contents-input_stream.output), input_stream.output_len);
			while (keep_going > 0 && done_objects<MAX_OBJECTS && unpacked_length<input_stream.output_len)
			{
				Change_progress_bar (STATUS_BAR3_UPDATE, window, (unsigned long)(contents-input_stream.output), input_stream.output_len);
				ani_mouse ();

				PREPARE_CONTENTS

				keep_going = read_contents_command (&contents, input_stream.output_len, digits_);

				if(keep_going==(TEXT_OPERATORS+16))									/* BT - start of the text part	*/
				{
				/*	first_TD = TRUE;	*/
					aa=bb=cc=dd=ee=ff=1000;
					dx=dy=0;
					text_state.rotate = 0;
					first_TD = TRUE;
					while(keep_going!=(TEXT_OPERATORS+17) && strlen1(contents)>0 && done_objects<MAX_OBJECTS && ((unsigned long)(contents-input_stream.output))<input_stream.output_len)							/* Repeat it until we get the end of the text part	*/
					{
						PREPARE_CONTENTS
						Change_progress_bar (STATUS_BAR3_UPDATE, window, (unsigned long)(contents-input_stream.output), input_stream.output_len);
						keep_going = read_contents_command (&contents, input_stream.output_len, digits_);

						switch(keep_going)
							{
							case (TEXT_STATE_OPERATOR+4):
							case (TEXT_STATE_OPERATOR+5):			/* rg and RG	and SC and sc	*/
								act_graf_state.rgb[0] = (int)digits[0];
								act_graf_state.rgb[1] = (int)digits[1];
								act_graf_state.rgb[2] = (int)digits[2];
								if(keep_going==(TEXT_STATE_OPERATOR+4) || keep_going==(TEXT_STATE_OPERATOR+5))
									text_state.color = FindColorByRGB (act_graf_state.rgb, 1);
								break;
							case (TEXT_OPERATORS+0):											/*	Tc	*/
								text_state.Tc = digits[0];
								break;
							case (TEXT_OPERATORS+1):											/*	Tw	*/
								text_state.Tw = digits[0];
								break;
							case (TEXT_OPERATORS+2):											/*	Tz	*/
								text_state.Tz = digits[0];
								break;
							case (TEXT_OPERATORS+3):											/*	TL	*/
								text_state.TL = digits[0];
								break;
							case (TEXT_OPERATORS+4):											/*	Tf	*/
								text_state.base_Tfs = digits[0];
								text_state.Tfs = (unsigned long)((aa/1000UL)*text_state.base_Tfs);
								current_font = SetFont (wind, names, resource);
								break;
							case (TEXT_OPERATORS+5):											/*	Tr	*/
								text_state.Tr = digits[0];
								break;
							case (TEXT_OPERATORS+6):											/*	Ts	*/
								text_state.Ts = digits[0];
								break;
							case (TEXT_OPERATORS+7):											/*	Th	*/
								text_state.Th = digits[0];
								break;

							case (TEXT_OPERATORS+8):											/*	Tj: (Text)Tj	*/
								{
								int text_len_in=0, text_len_out=0;

								read_text(contents, output1, &text_len_in, &text_len_out, current_font->type, FALSE, current_font);
								contents += (2+text_len_out/2);
								while(*contents!='j')
									contents++;
								contents++;

								add_pdf_object (wind, TEXT_OPERATORS+8, (short)text_state.color, (short)(text_state.Tfs / 1000L),
																(short)text_state.rotate,
																(unsigned long)(text_state.pos_x / 1000L),
															  (unsigned long)((text_state.Tfs + text_state.pos_y) / 1000L),
															  output1, (short)(text_len_out), text_state.Tc, text_state.Tw, text_state.Th, current_font);

								memset (output1, 0, text_len_out);
								}
							break;

							case (TEXT_OPERATORS+9):										/*	TJ: [(text)6.9(text1)]TJ	*/
							{
								unsigned long text_len=0, short_number_len=0;
								int short_text_len_in=0, short_text_len_out=0;
								signed long *dis_x=(signed long*)malloc(5000);

								if(dis_x==NULL)
									break;

								i = unpacked_length;
								if(*contents=='[')
									contents++;

								memset(dis_x, 0, 5000);

								while(*contents!=']')
									{
									read_text(contents, &output1[text_len], &short_text_len_in, &short_text_len_out, current_font->type, TRUE, current_font);
									contents += (2+short_text_len_in);

									text_len += short_text_len_out;

									if(*contents==')' && (*(contents+1))==']')
										break;

									if(contents[i]!=']')
										{
										dis_x[text_len*2] = read_number(contents, &short_number_len);
										contents += strcspn(contents, "(]");
										}
									}
								while(*contents!='J')
									contents++;
								contents++;
							
								add_pdf_object (wind, TEXT_OPERATORS+9, (short)text_state.color, (short)(text_state.Tfs / 1000L),
																(short)text_state.rotate,
																(unsigned long)(text_state.pos_x / 1000L),
															  (unsigned long)((text_state.Tfs + text_state.pos_y) / 1000L), 
															  output1, (short)(text_len),
															  dis_x, text_state.Tc, text_state.Tw, text_state.Th, current_font);

								memset (output1, 0, text_len);
								free(dis_x);
							}
							break;

							case (TEXT_OPERATORS+10):										/*	Td	*/
							case (TEXT_OPERATORS+11):										/*	TD	*/

								if(first_TD==TRUE)
									{
									text_state.pos_x = digits[0];
									text_state.pos_x += move_txt_x;

									text_state.pos_y = digits[1];
									text_state.pos_y += move_txt_y;
									first_TD = FALSE;
									}
								else if(first_TD==FALSE)
									{
									if(text_state.pos_x != (1000UL*win_x + text_w*(unsigned long)(digits[0])))
										{
										dummy_lenght = digits[0];
										dummy_lenght = (signed long)((signed long)dd*(signed long)dummy_lenght / 1000L);
										text_state.pos_x = (signed long)((signed long)text_state.pos_x + (signed long)dummy_lenght);
										}
									else
										text_state.pos_x = 1000UL*win_x;

									dummy_lenght = digits[1];
									dummy_lenght = (signed long)((signed long)aa*(signed long)dummy_lenght / 1000L);
									text_state.pos_y = (signed long)((signed long)text_state.pos_y + (signed long)dummy_lenght);
									}
									
								break;

							case (GRAPHIC_STATE_OPERATOR+2):
							case (TEXT_OPERATORS+12):										/*	Tm - text positioning operator	*/
								aa = digits[0];
								bb = digits[1];
								cc = digits[2];
								dd = digits[3];
								ee = digits[4];
								ff = digits[5];

								if(ee!=0 && ff!=0 && bb==0 && cc==0)					/* New position and size	*/
									{
									dummy_lenght = (aa*text_state.base_Tfs)/1;
									text_state.Tfs = (unsigned long)(dummy_lenght/1000UL);
									text_state.rotate = 0;
									}
								else if(ee!=0 && ff!=0 && bb!=0 && cc!=0)					/* New position, size	and rotation*/
									{
									text_state.rotate = (unsigned long)((double)1000*asin( (double)((double)aa/(double)100000UL)));
									text_state.rotate = 900 - (unsigned long)((((double)18UL/M_PI) * (double)text_state.rotate)/1);

									dx = (unsigned long)(text_state.Tfs * cos( ((double)(900-text_state.rotate)/10)/((double)18UL/M_PI)));
									if(sin( ((double)(900-text_state.rotate)/10)/((double)18UL/M_PI)) != 0 && text_state.Tfs!=0)
										dy = (unsigned long)((dx*dx/text_state.Tfs) / sin( ((double)(900-text_state.rotate)/10)/((double)18UL/M_PI)));
									else
										dy = 0;
									}
								text_state.pos_x = (signed long)ee;
								text_state.pos_y = (signed long)ff;

								text_state.pos_x -= dx;
								text_state.pos_y -= dy;

								first_TD = FALSE;
								break;

							case (TEXT_OPERATORS+13):										/*	T*	*/
								text_state.pos_y -= text_state.Tfs;
								break;
							case (TEXT_OPERATORS+14):										/*	'		*/
								break;
							case (TEXT_OPERATORS+15):										/*	"		*/
								break;


							case (TEXT_STATE_OPERATOR+0):
							case (TEXT_STATE_OPERATOR+1):										/*	rg, RG	*/
								text_state.rgb[0] = digits[0];
								text_state.rgb[1] = digits[1];
								text_state.rgb[2] = digits[2];

								text_state.color = FindColorByRGB (text_state.rgb, 1);
								break;

							case (TEXT_STATE_OPERATOR+2):
							case (TEXT_STATE_OPERATOR+3):											/* k and K	*/
								text_state.cmyk[0] = digits[0];
								text_state.cmyk[1] = digits[1];
								text_state.cmyk[2] = digits[2];
								text_state.cmyk[3] = digits[3];

								CMYK2RGB (text_state.cmyk, text_state.rgb);
								text_state.color = FindColorByRGB (text_state.rgb, 1);
								break;
							}
						}
					}							/* ************* END OF TEXT OPERATORS	*/

				else 
					{
					switch(keep_going)
						{
						case (GRAPHIC_STATE_OPERATOR+2):
							{								/*	cm	*/
							act_graf_state.CTM.a = digits[0];
							act_graf_state.CTM.b = digits[1];
							act_graf_state.CTM.c = digits[2];
							act_graf_state.CTM.d = digits[3];

							act_graf_state.CTM.e = text_state.pos_x = digits[4];

							act_graf_state.CTM.f = text_state.pos_y = digits[5];
							first_TD = FALSE;

							if(act_graf_state.CTM.a==1000 && act_graf_state.CTM.b==0 && act_graf_state.CTM.c==0 && act_graf_state.CTM.d==1000)
								{
								move_txt_x += act_graf_state.CTM.e;
								move_txt_y += act_graf_state.CTM.f;
								}
							break;
							}

						case (PATH_CONSTRUCTION_OPERATOR+0):							/*	'm'	- sets the starting position	*/
							{
							act_graf_state.pos_x = digits[0];
							act_graf_state.pos_y = digits[1];

							objects[done_objects].type = 1;
							objects[done_objects].x1 = act_graf_state.pos_x;
							objects[done_objects].y1 = act_graf_state.pos_y;
							done_objects++;
							break;
							}

						case (PATH_CONSTRUCTION_OPERATOR+1):							/*	'l'	- draws an line starting from act_graf_state.pos_x(y)	*/
							{
							objects[done_objects].type = 2;
							objects[done_objects].x1 = 		digits[0];
							objects[done_objects++].y1 =	digits[1];
							break;
							}

						case (PATH_CONSTRUCTION_OPERATOR+2):							/*	c	*/
							{
							objects[done_objects].x1 = digits[0];
							objects[done_objects].y1 = digits[1];

							objects[done_objects].x2 = digits[2];
							objects[done_objects].y2 = digits[3];

							objects[done_objects].x3 = digits[4];
							objects[done_objects].y3 = digits[5];

							objects[done_objects].type = 4;
							done_objects++;
							break;
							}

						case (PATH_CONSTRUCTION_OPERATOR+3):							/*	v	*/
							break;
						case (PATH_CONSTRUCTION_OPERATOR+4):							/*	y	*/
							break;
						case (PATH_CONSTRUCTION_OPERATOR+5):							/*	'h' - Close the current subpath	*/
							{
							objects[done_objects].x1 = objects[0].x1;
							objects[done_objects].y1 = objects[0].y1;
							done_objects++;
							break;
							}

						case (PATH_CONSTRUCTION_OPERATOR+6):							/*	're'	- paints an rectangle	*/
							{
							objects[done_objects].type = 3;

							objects[done_objects].x1 = digits[0];
							objects[done_objects].y1 = digits[1];

							objects[done_objects].x2 = objects[done_objects].x1 + digits[2];
							objects[done_objects].y2 = objects[done_objects].y1 + digits[3];

							done_objects++;
							break;
							}

						case (PATH_PAINTING_OPERATOR+0):			/* PAINT THE PATH CONSTRUCTION	*/
						case (PATH_PAINTING_OPERATOR+1):			/* this will work completly other in the future when we find a way how to paint in different modes. */
						case (PATH_PAINTING_OPERATOR+2):
						case (PATH_PAINTING_OPERATOR+3):
						case (PATH_PAINTING_OPERATOR+4):
						case (PATH_PAINTING_OPERATOR+5):
						case (PATH_PAINTING_OPERATOR+6):
						case (PATH_PAINTING_OPERATOR+7):
						case (PATH_PAINTING_OPERATOR+8):
						case (PATH_PAINTING_OPERATOR+9):
							{																								
							add_pdf_object (wind, keep_going, &act_graf_state, objects, done_objects);
							memset (objects, 0, 1000 * sizeof (struct path_objects));
							done_objects = 0;
							break;
							}

						case (OBJECT_POSITIONING_OPERATOR+0):										/* Do	*/
							{
					/* First we have to find the picture name and then find it on the list!!!!	*/
							pict_dummy = resource->pictures;
							pict_dummy = Find_picture(pict_dummy, names);

							if(pict_dummy!=NULL)
								{
								add_pdf_object (wind, keep_going, pict_dummy, (short)(act_graf_state.CTM.a/1000L), (short)(act_graf_state.CTM.b/1000L), (short)(act_graf_state.CTM.c/1000L),
																(short)(act_graf_state.CTM.d/1000L), (short)(act_graf_state.CTM.e/1000L), (short)(act_graf_state.CTM.f/1000L), (unsigned long)(&file_info->buffer[pict_dummy->stream_pos+strlen1("stream")]));
								}
							break;
							}

						case (TEXT_STATE_OPERATOR+0):		/* rg and RG	and SC and sc	*/
						case (TEXT_STATE_OPERATOR+1):
						case (TEXT_STATE_OPERATOR+4):
						case (TEXT_STATE_OPERATOR+5):
							{
							act_graf_state.rgb[0] = (int)digits[0];
							act_graf_state.rgb[1] = (int)digits[1];
							act_graf_state.rgb[2] = (int)digits[2];

							if(keep_going==(TEXT_STATE_OPERATOR+1) || keep_going==(TEXT_STATE_OPERATOR+4))
								act_graf_state.line_color = FindColorByRGB (act_graf_state.rgb, 1);
							else
								act_graf_state.fill_color = FindColorByRGB (act_graf_state.rgb, 1);
							break;
							}

						case (TEXT_STATE_OPERATOR+2):			/* k and K	*/
						case (TEXT_STATE_OPERATOR+3):
							{
							act_graf_state.cmyk[0] = (int)digits[0];
							act_graf_state.cmyk[1] = (int)digits[1];
							act_graf_state.cmyk[2] = (int)digits[2];
							act_graf_state.cmyk[3] = (int)digits[3];

							CMYK2RGB(act_graf_state.cmyk, act_graf_state.rgb);
							act_graf_state.line_color = FindColorByRGB (act_graf_state.rgb, 1);
							break;
							}

						case (TEXT_STATE_OPERATOR+6):					/* g, G	*/
						case (TEXT_STATE_OPERATOR+7):
							{
							num_len = (int)digits[0];
							if(500>num_len)
								num_len = BLACK;		/* BLACK	*/
							else
								num_len = WHITE;		/* WHITE - TO BE MODIFIED LATER	*/

							if(keep_going==(TEXT_STATE_OPERATOR+7))
								act_graf_state.line_color = num_len;
							else
								act_graf_state.fill_color = num_len;
							break;
							}

						case (GRAPHIC_STATE_OPERATOR+0):						/*	q	*/
							{
							Store_gfx_state();
							break;
							}
						case (GRAPHIC_STATE_OPERATOR+1):						/*	Q	*/
							{
							Restore_gfx_state();
							break;
							}

/*						case (GRAPHIC_STATE_OPERATOR+2):						/*	cm	*/
							{
							act_graf_state.CTM.a = digits[0];
							act_graf_state.CTM.b = digits[1];
							act_graf_state.CTM.c = digits[2];
							act_graf_state.CTM.d = digits[3];
							act_graf_state.CTM.e = digits[4];
							act_graf_state.CTM.f = digits[5];

							if(act_graf_state.CTM.a==1 && act_graf_state.CTM.b==0 && act_graf_state.CTM.c==0 && act_graf_state.CTM.d==1)
								{
								move_txt_x += act_graf_state.CTM.e;
								move_txt_y += act_graf_state.CTM.f;
								}
							break;
							}
*/
						case (GRAPHIC_STATE_OPERATOR+3):						/*	W	*/
							{
		/*						act_graf_state.line_width = digits[0];			/* Sets the line width	*/			*/
							break;
							}

						case (GRAPHIC_STATE_OPERATOR+4):						/*	w	*/
							{
							act_graf_state.line_width = digits[0];			/* Sets the line width	*/
							break;
							}

						case (GRAPHIC_STATE_OPERATOR+5):						/*	j	*/
							{
							break;
							/* Sets the line cap	*/
							}

						case (GRAPHIC_STATE_OPERATOR+6):						/*	J	*/
							{
							break;
						/* Sets the line join style	*/
							}

						case (GRAPHIC_STATE_OPERATOR+7):						/*	d	*/
							{
							while(*contents!=']')
								contents++;
							while(*contents!='d')
								contents++;
							break;
							/* Sets the line dash pattern	*/
							}

						case (GRAPHIC_STATE_OPERATOR+9):						/*	ri	*/
							{
							break;
							/* Sets the color rendering intent of the gfx state	*/
							}

						case (GRAPHIC_STATE_OPERATOR+10):						/*	i	*/
							{
							break;
							/* Sets the flattnes tolerance	*/
							}

						case (GRAPHIC_STATE_OPERATOR+11):					/*	gs	*/
							{
							break;
							/* Sets the gfx state dictionary name	*/
							}
						}
					}
				}
			}
		}
	}

	Change_progress_bar (STATUS_BAR1_UPDATE, window, 3, 4);
	Change_progress_bar (STATUS_BAR3_UPDATE, window, 0, 1);

	GoBack(pdf_info);
	keep_going=1;


		if(pdf_info->pages_contents[0].page_no>0)
			{
			if(pdf_info->pages_contents[1].page_no>0)
				{
				if(pdf_info->pages_contents[2].adress)
					{
					Free_Page_Contents((struct page_contents *)pdf_info->pages_contents[2].adress);
					}
				pdf_info->pages_contents[2].adress =		pdf_info->pages_contents[1].adress;
				pdf_info->pages_contents[2].cont_len =	pdf_info->pages_contents[1].cont_len;
				pdf_info->pages_contents[2].page_no =		pdf_info->pages_contents[1].page_no;
				}
			pdf_info->pages_contents[1].adress =		pdf_info->pages_contents[0].adress;
			pdf_info->pages_contents[1].cont_len =	pdf_info->pages_contents[0].cont_len;
			pdf_info->pages_contents[1].page_no =		pdf_info->pages_contents[0].page_no;
			}

		pdf_info->pages_contents[0].adress =		(void*)page_content;
		pdf_info->pages_contents[0].cont_len =	input_stream.output_len;
		pdf_info->pages_contents[0].page_no =		pdf_info->page_no;


		if(input_stream.input!=NULL && input_stream.input!=input_stream.output)
			free(input_stream.input);									/* ????????	*/
		if(objects)
			free(objects);

	graf_mouse (ARROW, 0L);
	free(output1);

	Check_gfx_state();

#ifdef STAT
	Update_statisticks("Init_display_page", 0);
	Exit_statistics();
#endif
}



	/* Add object to display: */
void add_pdf_object (WIND_LIST *wind, short type, ...)
{
	va_list arg;
	PDF_OBJECT *pdf_object=NULL;
	WIND_INFO *wind_info=NULL;
	static PDF_OBJECT *last_pdf_object;

#ifdef STAT
	Update_statisticks("add_pdf_object", 1);
#endif

	if(type==0)
		last_pdf_object = NULL;

	if (! type)												/* if it's first object (white page), we clear an existing list */
		clear_all_pdf_objects (wind);

	va_start (arg, type);

	wind_info = (WIND_INFO *)(wind->w_user1);

		/* creates a new object: */
	if ((pdf_object = wind_info->pdf_object) == 0L || last_pdf_object == NULL)
		wind_info->pdf_object = pdf_object = (PDF_OBJECT *)malloc (sizeof (PDF_OBJECT));
	else
		{
		pdf_object = last_pdf_object;
		pdf_object = pdf_object->next = (PDF_OBJECT *)malloc (sizeof (PDF_OBJECT));
		}

	last_pdf_object = pdf_object;


	if(pdf_object==NULL)
		return;

	switch (pdf_object->type = type)
	{
		case 0:												/* first operation: just draw a white page */
		{
			short *pxy;

			pxy = va_arg (arg, short *);
			pdf_object->spec.white_page.pxy[0] = *(pxy ++);
			pdf_object->spec.white_page.pxy[1] = *(pxy ++);
			pdf_object->spec.white_page.pxy[2] = *(pxy ++);
			pdf_object->spec.white_page.pxy[3] = *(pxy);
		}
		break;
		case TEXT_OPERATORS+4:								/* Tf */
			pdf_object->spec.Tf.TT_id = va_arg (arg, short);
			pdf_object->spec.Tf.italic_angle = va_arg (arg, short);
			pdf_object->spec.Tf.effect = va_arg (arg, short);
		break;
		case TEXT_OPERATORS+8:								/* Tj */
		case TEXT_OPERATORS+9:								/* TJ */
		{
			short len, *text;

			if(pdf_object->type==(TEXT_OPERATORS+8))
				pdf_object->spec.Tj.TJ = FALSE;
			else
				pdf_object->spec.Tj.TJ = TRUE;

			pdf_object->spec.Tj.color = va_arg (arg, short);
			pdf_object->spec.Tj.Tfs = va_arg (arg, short);
			pdf_object->spec.Tj.rotate = va_arg (arg, short);
			pdf_object->spec.Tj.pos_x = va_arg (arg, unsigned long);
			pdf_object->spec.Tj.pos_y = va_arg (arg, unsigned long);
			text = va_arg (arg, short *);
			len = va_arg (arg, short);
			pdf_object->spec.Tj.text = (short *)malloc (len+2);
			memcpy (pdf_object->spec.Tj.text, text, len);
			pdf_object->spec.Tj.len = len >> 1;

			if(pdf_object->type==(TEXT_OPERATORS+9))
				{
				pdf_object->spec.Tj.dis_x = (signed long *)malloc (4*len+2);
				memcpy(pdf_object->spec.Tj.dis_x, va_arg(arg, signed long *), 4*len);
				}
			pdf_object->spec.Tj.Tc = va_arg (arg, unsigned long);
			pdf_object->spec.Tj.Tw = va_arg (arg, unsigned long);
			pdf_object->spec.Tj.Th = va_arg (arg, unsigned long);
			pdf_object->spec.Tj.actual_font = (struct fonts*)va_arg (arg, unsigned long);
		}
		break;
		case PATH_PAINTING_OPERATOR+0:						/* PAINT THE PATH CONSTRUCTION	*/
		case PATH_PAINTING_OPERATOR+1:
		case PATH_PAINTING_OPERATOR+2:
		case PATH_PAINTING_OPERATOR+3:
		case PATH_PAINTING_OPERATOR+4:
		case PATH_PAINTING_OPERATOR+5:
		case PATH_PAINTING_OPERATOR+6:
		case PATH_PAINTING_OPERATOR+7:
		case PATH_PAINTING_OPERATOR+8:
		case PATH_PAINTING_OPERATOR+9:
			{
			void *adress=NULL;

/* First we have to store the pointer to the objects, then we need to know how 
	many objects do we have to copy. Next we are allocating memory and copying the objects :) */
			
			pdf_object->spec.path_construction.path = *va_arg (arg, struct graphical_state *);
			adress = (void*)va_arg (arg, struct path_objects *);
			pdf_object->spec.path_construction.done_objects = va_arg (arg, unsigned long);
			pdf_object->spec.path_construction.objects = NULL;
			if(pdf_object->spec.path_construction.done_objects>0)
				{
				pdf_object->spec.path_construction.objects = (struct path_objects *)calloc (1, sizeof (struct path_objects) * pdf_object->spec.path_construction.done_objects);
				if(pdf_object->spec.path_construction.objects!=NULL)
					memcpy (pdf_object->spec.path_construction.objects, adress, sizeof (struct path_objects) * pdf_object->spec.path_construction.done_objects);
				else
					x_gem_alert("[3][Problem with memory | in add_pdf_object][Hmmm]", 0L);
				}
			else
				x_gem_alert("[3][No objectes | to copy][Hmmm]", 0L);
			}
		break;
		case OBJECT_POSITIONING_OPERATOR:		/* Do	*/
			pdf_object->spec.Pic.picture = va_arg (arg, struct picture *);
			pdf_object->spec.Pic.a = va_arg (arg, short);
			pdf_object->spec.Pic.b = va_arg (arg, short);
			pdf_object->spec.Pic.c = va_arg (arg, short);
			pdf_object->spec.Pic.d = va_arg (arg, short);
			pdf_object->spec.Pic.e = va_arg (arg, short);
			pdf_object->spec.Pic.f = va_arg (arg, short);
			pdf_object->spec.Pic.stream = (char*)(va_arg (arg, unsigned long));
		break;
	}

	pdf_object->next = 0L;

	va_end (arg);

#ifdef STAT
	Update_statisticks("add_pdf_object", 0);

	vq_key_s(x_gem->handle, (INT16*)&key);
	if(key&2)
		Display_page (wind);
	if(key==10)
		{
		while(key==10)
			vq_key_s(x_gem->handle, (INT16*)&key);
		}
#endif
}


	/* clear all pdf objects (when we close the window, or if page changes): */
void clear_all_pdf_objects (WIND_LIST *wind)
{
	PDF_OBJECT *pdf_object, *pdf_object2;
	WIND_INFO *wind_info;

	if (! wind)
		return;

	if ((wind_info = (WIND_INFO *)(wind->w_user1)) == 0L)
		return;

	if ((pdf_object2 = wind_info->pdf_object) == 0L)
		return;

	while ((pdf_object = pdf_object2) != 0L)
	{
		pdf_object2 = pdf_object->next;

		switch (pdf_object->type)
		{
			case TEXT_OPERATORS+8:
			case TEXT_OPERATORS+9:
				if(pdf_object->spec.Tj.text)
					free (pdf_object->spec.Tj.text);
				if(pdf_object->spec.Tj.TJ==TRUE)
					free (pdf_object->spec.Tj.dis_x);
			break;
			case PATH_PAINTING_OPERATOR+0:
			case PATH_PAINTING_OPERATOR+1:
			case PATH_PAINTING_OPERATOR+2:
			case PATH_PAINTING_OPERATOR+3:
			case PATH_PAINTING_OPERATOR+4:
			case PATH_PAINTING_OPERATOR+5:
			case PATH_PAINTING_OPERATOR+6:
			case PATH_PAINTING_OPERATOR+7:
			case PATH_PAINTING_OPERATOR+8:
			case PATH_PAINTING_OPERATOR+9:
				if(pdf_object->spec.path_construction.objects)
					free (pdf_object->spec.path_construction.objects);
			break;
		}

		free (pdf_object);
	};

	wind_info->pdf_object = 0L;
}


	/* The page is displayed here: */
void Display_page (WIND_LIST *wind)
{
	short dummy, handle, x, y, pxy[4];
	static int prev_font_id;
	WIND_INFO *wind_info;
	PDF_OBJECT *pdf_object;

#ifdef STAT
	Update_statisticks("Display_page", 1);
#endif


	if (! wind)
		return;

	if ((wind_info = (WIND_INFO *)(wind->w_user1)) == 0L)
		return;

	if ((pdf_object = wind_info->pdf_object) == 0L)
		return;

	handle = x_gem->handle;

	vst_font (handle, 5003);
	vst_height (handle, x_gem->sys_font_size, &dummy, &dummy, &dummy, &dummy);
	vst_alignment (handle, 0, 5, &dummy, &dummy);
	vst_color (handle, BLACK);
	vst_effects (handle, MF_NORMAL);

	Change_progress_bar (STATUS_BAR1_UPDATE, wind_info->pdf_info->window_number, 4, 4);

	x = wind->w_work_wind.g_x - (short)wind->w_pos_x;
	y = wind->w_work_wind.g_y - (short)wind->w_pos_y;

	if(options.use_cache==TRUE)
		Save_cache(wind_info);

	while (pdf_object)
	{
		switch (pdf_object->type)
		{
			case 0:												/* first operation: just draw a white page */
			{
				short *p;

				vsf_color (handle, WHITE);
				vsf_interior (handle, FIS_SOLID);
				p = pdf_object->spec.white_page.pxy;

				pxy[0] = wind->w_work_wind.g_x;
				pxy[1] = wind->w_work_wind.g_y;
				pxy[2] = pxy[0] + wind->w_work_wind.g_w - 1;
				pxy[3] = pxy[1] + wind->w_work_wind.g_h - 1;
				vs_clip(handle, 1, &pxy[0]);

				pxy[0] = x + *(p ++) + (short)wind->w_pos_x;
				pxy[1] = y + *(p ++) + (short)wind->w_pos_y;
				pxy[2] = x + wind_info->pdf_info->page_w + (short)wind->w_pos_x;
				pxy[3] = y + wind_info->pdf_info->page_h + (short)wind->w_pos_y;
				vr_recfl (handle, pxy);
			}
			break;
			case TEXT_OPERATORS+4:								/* Tf */
			{
				OB_Tf *Tf;

				Tf = &pdf_object->spec.Tf;
				if (Tf->TT_id > 0)
					{
					vst_font (handle, Tf->TT_id);
					prev_font_id = Tf->TT_id;
					}
				else
					{
					if(prev_font_id!=0)
						vst_font( handle, prev_font_id);
					else
						vst_font( handle, 17746);	/* 13373 Swiss 721 */
					}

			/*	vst_skew (handle, Tf->italic_angle);	*/
				vst_effects (handle, Tf->effect);
			}
			break;
			case TEXT_OPERATORS+8:								/* Tj */
			case TEXT_OPERATORS+9:								/* TJ */
			{
				OB_Tj *Tj;

				Tj = &pdf_object->spec.Tj;

				if(pdf_object->type==(TEXT_OPERATORS+8))
					Display_text(handle, x, y, Tj, FALSE, wind_info->pdf_info);
				else
					Display_text(handle, x, y, Tj, TRUE, wind_info->pdf_info);
			}
			break;

			case PATH_PAINTING_OPERATOR+0:						/* PAINT THE PATH CONSTRUCTION	*/
			case PATH_PAINTING_OPERATOR+1:
			case PATH_PAINTING_OPERATOR+2:
			case PATH_PAINTING_OPERATOR+3:
			case PATH_PAINTING_OPERATOR+4:
			case PATH_PAINTING_OPERATOR+5:
			case PATH_PAINTING_OPERATOR+6:
			case PATH_PAINTING_OPERATOR+7:
			case PATH_PAINTING_OPERATOR+8:
			case PATH_PAINTING_OPERATOR+9:
			{
				OB_PATH_CONSTRUCTION *path_construction;

				path_construction = &pdf_object->spec.path_construction;
				if(draw_path (handle, pdf_object->type, &path_construction->path, path_construction->objects, path_construction->done_objects, x, y, wind_info->pdf_info->page_h, wind_info->pdf_info->scale)!=1)
					x_gem_alert ("Ooops, not enough memory", 0L);
			}
			break;
			case OBJECT_POSITIONING_OPERATOR:
			{
				OB_Picture *picture=&pdf_object->spec.Pic;

				Display_picture(handle, x, y, picture, wind_info->pdf_info);
			}
			break;
		}

		pdf_object = pdf_object->next;
	};
	Change_progress_bar (STATUS_BAR1_UPDATE, wind_info->pdf_info->window_number, 0, 0);

#ifdef STAT
	Update_statisticks("Display_page", 0);
#endif
}




/*
	Instead of this routine we could use the NVDI function #204.
	But if we want to make it usable also without NVDI - then we have
	to write our own routine...
	Or we could use the NVDI routine if present in other case we
	could use ours ;-)

	er: Some little optimisations...
*/

short FindColorByRGB (short *table, short mode)
{
	short r, g, b, color, i, m, m2, nb_color, *palette;

	r = *(table ++);
	g = *(table ++);
	b = *(table);

	if (! mode)
	{
		r *= 3.92;
		g *= 3.92;
		b *= 3.92;
	}

	nb_color = x_gem->work_out[13];
	m2 = 1000;

	palette = sys_pal;

	for (i = 0; i < nb_color; i ++)
	{
		m = (abs (r - *(palette ++)) + abs (g - *(palette ++)) + abs (b - *(palette ++))) / 3;
		if (m < m2)
		{
			color = i;
			if (! m)
				return (color);
			m2 = m;
		}
	}

	if ((color == WHITE) && ((r != 1000) || (g != 1000) || (b != 1000)))
		color = BLACK;

	return (color);
}


void CMYK2RGB (short *table_in, short *table_out)
{
	short c,m,y,k;
	short r=0,g=0,b=0;

	c=table_in[0];
	m=table_in[1];
	y=table_in[2];
	k=table_in[3];

	if (k > 0)
		{
		c += k;
		m += k;
		y += k;
		}

	r = 1000 - c;
	g= 1000 - m;
	b = 1000 - y;

	if(r < 0)
		r = 0;
	else if (r > 1000)
    r = 1000;

  if (g < 0)
    g = 0;
  else if (g > 1000)
    g = 1000;

  if (b < 0.0)
    b = 0;
  else if (b > 1000)
    b = 1000;

	table_out[0] = r;
	table_out[1] = g;
	table_out[2] = b;
}



void Store_gfx_state(void)
	{
	struct graphical_state *dummy=NULL;
	
	if(base_graf_state==NULL)
		{
		base_graf_state = calloc(1, sizeof(struct graphical_state));
		dummy = base_graf_state;
		dummy->how_many = 1;
		dummy->number = 1;
		}
	else
		{
		dummy = base_graf_state;
		while(dummy->next_graf_state!=NULL && dummy->number<=base_graf_state->number)
			dummy = dummy->next_graf_state;
		dummy->next_graf_state = calloc(1, sizeof(struct graphical_state));
		dummy->next_graf_state->prev_graf_state = dummy;
		dummy = dummy->next_graf_state;
		dummy->next_graf_state = NULL;
		}

	memcpy(dummy, &act_graf_state, sizeof(struct graphical_state)-8);
	base_graf_state->number = 1;
	base_graf_state->how_many++;
	if(dummy!=base_graf_state)
		dummy->number = base_graf_state->how_many;
	}



void Restore_gfx_state(void)
	{
	struct graphical_state *dummy=NULL;

	if(base_graf_state!=NULL)
		{
		dummy = base_graf_state;
		while(dummy->next_graf_state!=NULL && dummy->number<base_graf_state->how_many)
			dummy = dummy->next_graf_state;
		memcpy(&act_graf_state, dummy, sizeof(struct graphical_state)-8);
		if(dummy->prev_graf_state)
			dummy->prev_graf_state->next_graf_state = NULL;

		if(dummy==base_graf_state || base_graf_state->how_many==1)
			{
			free(base_graf_state);
			base_graf_state=NULL;
			}
		else
			{
			free(dummy);
			base_graf_state->how_many--;
			}
		}
	}

void Check_gfx_state(void)
	{
	if(base_graf_state)
		{
		if(base_graf_state->how_many!=0)
			x_gem_alert("[3][Warning!!|Not all graphical states|are freed][Hmm]", 0L);
		}
	}