
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<x_gem.h>
#include	<ctype.h>
#include	"memdebug.h"
#include	"mp_const.h"
#include	"files.h"
#include	"typespdf.h"
#include	"info_pdf.h"

void Replace_text(char *, char *, char *);


struct Replace
	{
	char *orig;
	char *repl;
	}speciall_character[]=
	{
	"\\n", " ",		 		/*	 Line feed									*/
	"\\r", " ",				/*	 Carriage return						*/
	"\\t", " ",		 		/*	 Horizontal tab							*/
	"\\b", " ",	 			/*	 Backspace									*/
	"\\f", " ", 			/*	 Form feed									*/
	"\\(", " ",	 			/*	 Left parenthesis						*/
	"\\)", " ",		 		/*	 Right parenthesis					*/
	"\\\\", " ", 			/*	 Backslash									*/
	"\\ddd",					/*	 Character code ddd (octal)	*/
	NULL
	};



/* ******************************************************** */
/*	Read_type																								*/
/* Reads a type: e.g.   /Page																*/
/* ******************************************************** */

char *Read_type(struct files_pdf *file)
	{
	static char *output;
	char *buffer = NULL;
	int i=0, j=0;

	if(output)
		{
		free(output);
		output=NULL;
		}

	if(file!=NULL)
		buffer = &file->buffer[file->actual_pos];
	else
		return(NULL);

	while(buffer[i++]==' ')	;
	i--;
	while(buffer[i]!=' ' && buffer[i]!='\r' && buffer[i]!='\n')	
		{
		i++;
		j++;
		}

	output = calloc(1, j+2);
	file->actual_pos += (j+1);
	i = j = 0;

	while(buffer[i++]==' ')	;
	i--;

	while(buffer[i]!=' ' && buffer[i]!='\r' && buffer[i]!='\n')	
		output[j++] = buffer[i++];

	return(output);
	}



int Ascii2Int(char *line)
	{
	int table[0]={10, 11, 12, 13, 14, 15, 16};
	int output=0;
	int i=0;

	while(isdigit(line[i])==0 && line[i]<'A' && line[i]>'F')
		i++;

	if(line[i]>='A' && line[i]<='F')
		output = 256*table[line[i]-'A'];
	else
		output = 256*(line[i]-'0');

	i++;
	if(line[i]>='A' && line[i]<='F')
		output += 16*table[line[i]-'A'];
	else
		output += 16*(line[i]-'0');

	i++;
	if(line[i]>='A' && line[i]<='F')
		output += table[line[i]-'A'];
	else
		output += (line[i]-'0');

	return(output);
	}

/* ******************************************************** */
/*	Read_text																								*/
/* Reads a text between brakets '(' and ')'									*/
/* ******************************************************** */
/* To do:																										*/
/*		- special characters like "\(", "\)"	etc.						*/
/*		- handling of files bigger then allowed								*/


struct PDF_Info *find_pdf_info_by_file(struct files_pdf *file_info);
BOOLEAN GoToObject(struct PDF_Info *info, unsigned int obj);
BOOLEAN GoBack(struct PDF_Info *info);
unsigned long Read_object_no(struct files_pdf *file);

char *Read_text(struct files_pdf *file)
	{
	static char *output;
	char *buffer = NULL;
	unsigned long size1=0;	/*size=0, prev_pos=0, pos=0;	*/
	int keep_doing = TRUE;
	BOOLEAN goback=FALSE;

	if(output)
		{
		free(output);
		output=NULL;
		}

	if(file!=NULL)
		{
		if(file->handle<=0)
			buffer = &file->buffer[file->actual_pos];
		else
			{
			buffer=calloc(1,1000);
			Fseek(file->actual_pos, file->handle, 0);
			read(file->handle, buffer, 998);
			}
		}
	else
		return(NULL);

	if((isdigit(buffer[0]) || isdigit(buffer[1]) || isdigit(buffer[2])) &&
			buffer[0]!='(' && buffer[1]!='(' && buffer[2]!='(')
		{
		goback=TRUE;
		GoToObject(find_pdf_info_by_file(file), (unsigned int)Read_object_no(file));
		buffer = &file->buffer[file->actual_pos];
		}

	buffer = strstr(buffer, "(");
/*	prev_pos = (unsigned long)buffer;	*/
	
	if(buffer==NULL)
		return(NULL);

/*
	This is the older version: probably its faster then the new one
	but its for sure not so clear and has some limitatins
	---------------------------------------------------------------
	while(keep_doing==TRUE)
		{
		size = (unsigned long)strstr(buffer, ")");
		if(size==0)
			{
			pos=strlen(buffer)+1;
			while(size==0)
				{
				size = (unsigned long)strstr(&buffer[pos], ")");
				if(size==0)
					pos += (1+strlen(&buffer[pos]));
				else
					size += pos;
				}
			}
		size -= prev_pos;
		size1 += size;

		if(buffer[size-1]!='\\')
			{
			keep_doing=FALSE;
			size1++;
			}
		else
			{
			prev_pos = (unsigned long)&buffer[size];
			size++;
			keep_doing=TRUE;
			}
		}
*/

	while(keep_doing==TRUE)
		{
		size1++;
		if(buffer[size1]==')' && buffer[size1-1]!='\\')
			keep_doing=FALSE;
		}



	if(size1>1)
		{
		output = calloc (1, size1 + 16);
		if(output)
			{
			strncpy(output, buffer+1, size1-1);
			if(file->handle>0)
				free(buffer);

		/*	Encode_text(output, size1-1);		*/					/* Encodes decoded text !!!!!!!!! TO DO!!!!!!!!!	*/
			
			file->actual_pos += (size1+2);

			while(strstr(output, "\\t")!=NULL)			/* Tabulator	*/
			{
				Replace_text(output, "\\t", " ");
			}
			while(strstr(output, "\\(")!=NULL)
			{
				Replace_text(output, "\\(", "(");
			}
			while(strstr(output, "\\)")!=NULL)
			{
				Replace_text(output, "\\)", ")");
			}
			while(strstr(output, "\\\\")!=NULL)
			{
				Replace_text(output, "\\\\", "\\");
			}
/*			while(strstr(output, "\\")!=NULL)
			{
				back = Ascii2Int(strstr(output,"\\"));
				strncpy(buf2, strstr(output, "\\"), 4);
				Replace_text(output, buf2, itoa(back, buffer, 10));
			}
*/

			if(goback==TRUE)
				GoBack(find_pdf_info_by_file(file));

			return(output);
			}
		}

	return(NULL);
	}