/********************************************************************
**
** Copyright (c) 2002 by Rafal Kawecki
**
** ASCII85 data decompression routine
**
** February 2002
**
**********************************************************************/

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<tos.h>
#include	<ctype.h>
#include	<x_gem.h>
#include	"memdebug.h"
#include	"status.h"

void ani_mouse (void);
void Change_progress_bar (int status, int window, unsigned long value, unsigned long max_value);


/* This routine gets an character from a string with a given position.
	If this char is a white char (like in isspace) then to the position is added 1.	*/
/* ER: a little bit optimised (if you want, compare the asm code with debugger ;) */

static char get_char (char *output, unsigned long *pos)
{
	char c;
	unsigned long i;

	i = *(pos);
	output += i;

	while ((c = *(output ++)) <= 32)					/* isspace () is too slow ;-) */
		i ++;

	*(pos) = ++ i;

	return (c);
}


/*
	This routine decodes an given string using the ASCII85Decode algorithm:

	 b1*256^3 + b2*256^2 + b3*256^1 + b4  =  c1*85^4 + c2*85^3 + c3*85^2 + c4*85^1 + c5

	The decoded string is returned. Length of the string to decode must be given to the routine
	as a parameter.
	The length of this string must be given as a pointer to unsigned long to the routine as a parameter. 

*/


/* ER: using real values is quicker with pure C ;-) */
/*static unsigned long value256[]={1, 256,	65536UL,	16777216UL};*/
/*static unsigned long value85[]= {1, 85,		7225,		614125UL,		52200625UL};*/

char *ASCII85Decode(int window, char *input, char *output, unsigned long size, unsigned long *real_size)
{
	unsigned long actual_pos_input=0;
	unsigned long value=0;
	char c1=0,c2=0,c3=0,c4=0,c5=0, c6=0;					/* The compressed stream		*/
	char b1, b2, b3, b4;									/* The uncompressed stream	*/

	if(output==NULL)
		return(NULL);

	Change_progress_bar (STATUS_BAR1_UPDATE, window, 0, size);
	Change_progress_bar (STATUS_PDF_UNCOM_ASCII85, window, 0, size);

	for (actual_pos_input=0; input[actual_pos_input]!='~' || input[actual_pos_input+1]!='>'; )	/* '~>' means EOD		*/
	{
		Change_progress_bar (STATUS_BAR1_UPDATE, window, actual_pos_input, size);
		ani_mouse ();

		c1 = get_char (input, &actual_pos_input) - 33;

		if ((c1 + 33) != 'z')								/* should I put 4 zeros to output stream ? */
		{													/* no, First we have to get the real value */
			c2 = get_char(input, &actual_pos_input) - 33;
			c3 = get_char(input, &actual_pos_input) - 33;
			c4 = get_char(input, &actual_pos_input) - 33;
			c5 = get_char(input, &actual_pos_input) - 33;
			c6 = get_char(input, &actual_pos_input);
			actual_pos_input --;

			value = (unsigned long)c1 * 52200625UL;			/* Now we calculate the whole value	*/
			value += (unsigned long)c2 * 614125UL;
			value += (unsigned long)c3 * 7225;
			value += (unsigned long)c4 * 85;
			value += (unsigned long)c5;

			if (value >= 16777216UL)
			{
				b1 = (char)(value/16777216UL);
				value -= (unsigned long)b1*16777216UL;
			}
			if (value >= 65536UL)
			{
				b2 = (char)(value/65536UL);
				value -= (unsigned long)b2*65536UL;
			}
			if (value >= 256)
			{
				b3 = (char)(value/256);
				value -= (unsigned long)b3*256;
			}

			b4 = (char)value;
		}
		else																		/* Put 4 zeros to output stream			*/
		{
			b1=b2=b3=b4=0;
		}

		output[*real_size] = b1;
		output[(*real_size)+1] = b2;
		output[(*real_size)+2] = b3;
		output[(*real_size)+3] = b4;

		if (((c1+33)=='~' && (c2+33)=='>') || ((c2+33)=='~' && (c3+33)=='>') || ((c3+33)=='~' && (c4+33)=='>') || ((c4+33)=='~' && (c5+33)=='>') || ((c5+33)=='~' && c6=='>'))
		{
			if((c1+33)=='~' && (c2+33)=='>')
				break;
			if((c2+33)=='~' && (c3+33)=='>')
				*real_size+=1;
			if((c3+33)=='~' && (c4+33)=='>')
				*real_size+=2;
			if((c4+33)=='~' && (c5+33)=='>')
				*real_size+=3;
			if((c5+33)=='~' && c6=='>')
				*real_size+=4;
			break;
		}
		else
			*real_size += 4;

		b1=b2=b3=b4=c1=c2=c3=c4=c5=c6=0;
	}

	return (output);
}

/* ******************************************	*/
