#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<tos.h>
#include	<x_gem.h>
#include	"mp_const.h"
#include	"memdebug.h"
#include	"status.h"

void ani_mouse (void);


unsigned input_code(char *input, unsigned long *pos, int mode);
void expand_lzw(int window, char *, char *, unsigned long , unsigned long *);
char *decode_string(unsigned char *, unsigned int );
void Change_progress_bar (int status, int window, unsigned long value, unsigned long max_value);


#define INIT_BITS 9										/* The starting bit number							*/
#define MAX_BITS 12         				  /* Do not exceed 12 in any of PDF files */
#define HASHING_SHIFT (MAX_BITS - 8)

#define TABLE_SIZE 5021
#define CLEAR_TABLE 256    /* Code to flush the string table */
#define TERMINATOR  257    /* To mark EOF Condition, instead of MAX_VALUE */
#define FIRST_CODE  258    /* First available code for code_value table */
#define CHECK_TIME  100    /* Check comp ratio every CHECK_TIME chars input */

#define MAXVAL(n) (( 1 <<( n )) -1)   /* max_value formula macro */

static int *code_value;                      /* This is the code value array */
static unsigned int *prefix_code;            /* This array holds the prefix codes */
static unsigned char *append_character;      /* This array holds the appended chars */
static unsigned char decode_stack[4000];     /* This array holds the decoded string */

static int num_bits=INIT_BITS;               /* Starting with 9 bit codes */
static int max_code;                         /* old MAX_CODE */


void expand_lzw(int window,char *input, char *output, unsigned long max_size, unsigned long *output_pos)
{
	unsigned long input_pos=0;
	unsigned int next_code=FIRST_CODE;
	unsigned int new_code;
	unsigned int old_code;
	int prev_bits = num_bits;
	int character, clear_flag=1;          /* Need to clear the code value array */
	unsigned char *string=NULL;


 /* The three buffers for the compression phase.  */

	code_value=calloc(1, TABLE_SIZE*sizeof(unsigned int));
	prefix_code=calloc(1, TABLE_SIZE*sizeof(unsigned int));
	append_character=calloc(1, TABLE_SIZE*sizeof(unsigned char));
	memset(decode_stack, 0, 4000);
	max_code=0;
	num_bits=INIT_BITS;
	input_code(NULL, NULL, 0);


	Change_progress_bar (STATUS_PDF_UNCOM_LZW, window, 0, 0);
	Change_progress_bar (STATUS_BAR3_UPDATE, window, 0, max_size);

	while((new_code=input_code(input, &input_pos, 1)) != TERMINATOR)	/* && max_size>(input_pos+2))	*/
	{
		Change_progress_bar (STATUS_BAR3_UPDATE, window, input_pos, max_size);
		ani_mouse ();											/* Animates the mouse pointer while rendering the page	*/

      if (clear_flag)
      {       /* Initialize or Re-Initialize */
	      if (new_code == CLEAR_TABLE)
  	    {     /* Clear string table */
    	     clear_flag=1;
      	   num_bits=INIT_BITS;
        	 next_code=FIRST_CODE;
  	       max_code = MAXVAL(num_bits);
    	     continue;
      	}
         clear_flag=0;
         old_code=new_code;   /* The next three lines have been moved */
         character=old_code;  /* from the original */
         output[(*output_pos)++] = old_code;			/*	putc(old_code,output);	*/
         continue;
      }
      if (new_code == CLEAR_TABLE)
      {     /* Clear string table */
         clear_flag=1;
         num_bits=INIT_BITS;
         next_code=FIRST_CODE;
         max_code = MAXVAL(num_bits);
         continue;
      }

      if (new_code >= next_code)
      {       /* Check for string+char+string */
         *decode_stack=character;
         string=decode_string(decode_stack+1,old_code);
      }
      else
         string=decode_string(decode_stack,new_code);
       
      character = *string;              /* Output decoded string in reverse */
      while (string >= decode_stack)
      	output[(*output_pos)++] = *string--;				/*	  putc(*string--,output);	*/

      if (next_code <= max_code)
	      {																			      /* Add to string table if not full */
         prefix_code[next_code]				 = old_code;
         append_character[next_code++] = character;
         if (next_code == max_code && num_bits < MAX_BITS)
            max_code = MAXVAL(++num_bits);
				if(prev_bits!=num_bits)
					prev_bits=num_bits;
  	    }
      old_code=new_code;
   }

	free(code_value);
	free(prefix_code);
	free(append_character);
}



/* UNCHANGED from original
 * Decode a string from the string table, storing it in a buffer.
 * The buffer can then be output in reverse order by the expansion
 * program.
 */
char *decode_string(unsigned char *buffer, unsigned int code)
{
   int i=0;

   while(code > 255 )
   {
      *buffer++ = append_character[code];
      code = prefix_code[code];
      if (i++ >= 4096 )
  	    x_gem_alert("[3][Error in decode_string][Aha...]", 0L);
   }
   *buffer=code;
   return(buffer);
}



/* UNCHANGED from original
 * Input a variable length code.
 */
unsigned input_code(char *input, unsigned long *pos, int mode)
{
   unsigned int return_value;
   static int input_bit_count=0;
   static unsigned long input_bit_buffer=0;

	if(mode==0)
		{
		input_bit_count = 0;
		input_bit_buffer = 0;
		return(0);
		}
	else
		{
		while (input_bit_count <= 24 )
			{
			input_bit_buffer |= (unsigned long) input[*pos] << (24 - input_bit_count);
			input_bit_count += 8;
			(*pos)++;
			}
		return_value=(unsigned int)(input_bit_buffer >> (32-num_bits));
		input_bit_buffer <<= num_bits;
		input_bit_count -= num_bits;
		return(return_value);
		}
}



/*
/*	Only for tests	!!!!!!!!!!	*/
void main(int argc, char *argv[])
{
	int output_file, lzw_file;
	char *input_stream=NULL, *output_stream=NULL;
	unsigned long size, out_size=0;
	char *out;

	lzw_file=open(argv[1],O_RDONLY);
	out=malloc(strlen(argv[1])+10);
	strcpy(out, argv[1]);
	out[strlen(out)-1]='1';
	output_file = creat(out);
	close(output_file);
	output_file=open(out,O_WRONLY);

	num_bits=INIT_BITS;                  /* Re-initialize for expansion */
	max_code = MAXVAL(num_bits);
	size = Fseek(0, lzw_file, 2);
	Fseek(0, lzw_file, 0);

	input_stream = malloc(size+100);
	output_stream = malloc(20*size+100);
	memset(input_stream, 0, size+50);
	memset(output_stream, 0, 20*size);
	read(lzw_file, (void*)input_stream, size);

	close(lzw_file);                    /* Clean it all up */
	out_size = 0;
	expand_lzw(input_stream, output_stream, size, &out_size);        /* Call expansion routine */
	write(output_file, (void*)output_stream, out_size);

	close(output_file);
	free(prefix_code);
	free(append_character);
	exit(0);
}
*/