#include	<mgem.h>
#include	<portab.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<tos.h>
#include	<ctype.h>
#include	"memdebug.h"
#include	"mp_const.h"
#include	"typespdf.h"
#include	"info_pdf.h"
#include	"files.h"
#include	"status.h"
#include	"options.h"


char *Read_text(struct files_pdf *);
int Command2ID(struct files_pdf *, char **);
unsigned long Read_object_no(struct files_pdf *);
struct Rectangle Read_rectangle(struct files_pdf *);
char *Read_last_line(struct files_pdf *);
char *Read_line2(struct files_pdf *);
char *read_line2(int );
char *Read_prev_line(struct files_pdf *);
char *read_prev_line(int );
long find_object_number (struct file_position *, int , unsigned int );
BOOLEAN load_objects(struct files_pdf);
BOOLEAN Load_objects(struct PDF_Info *,int);
void Depack_date(char *);
BOOLEAN GoToObject(struct PDF_Info *, unsigned int );
BOOLEAN GoBack(struct PDF_Info *);

extern struct opt options;

extern struct Root_obj *read_root_obj(struct PDF_Trailer *trailer, struct PDF_Info *info);

struct PDF_Bead_dict *read_bead_dict(struct PDF_Info *, int );


#define PDF_INFO_Title				1
#define PDF_INFO_Author				2
#define PDF_INFO_Subject			3
#define PDF_INFO_Keywords			4
#define PDF_INFO_Creator			5
#define PDF_INFO_Producer			6
#define PDF_INFO_CreationDate	7
#define PDF_INFO_ModDate			8
#define PDF_INFO_Trapped			9
#define PDF_INFO_Version			10

char *docu_info_commands[]={
		"/Title",
		"/Author",
		"/Subject",
		"/Keywords",
		"/Creator",
		"/Producer",
		"/CreationDate",
		"/ModDate",
		"/Trapped",
		"/Version",
		NULL};


struct docu_info *Read_docu_info(struct PDF_Info *info)
	{
	unsigned long actual_pos = info->file_info->actual_pos;
	struct files_pdf *file = info->file_info;
	char *line, buf[256]={0};
	struct docu_info *doc_info=calloc (1, sizeof (struct PDF_Outline));
	int keep_going=1;

	if(doc_info)
	{
		Change_status(STATUS_PDF_READ_INFO, 0, 0);
		/*Change_status(STATUS_BAR1_UPDATE, 0, 0);*/

		GoToObject(info, (unsigned int)info->Root_obj->Outlines);

		line = Read_line2(file);

		while(keep_going!=0)
		{
			switch((keep_going=Command2ID(file, docu_info_commands)))
			{
			case PDF_INFO_Title:
				line = Read_text(file);
				if ((doc_info->Title = malloc (strlen (line) + 1)) > 0L)
					strcpy (doc_info->Title, line);
				break;
			case PDF_INFO_Author:
				line = Read_text(file);
				if ((doc_info->Author = malloc (strlen (line) + 1)) > 0L)
					strcpy (doc_info->Author, line);
				break;
			case PDF_INFO_Subject:
				line = Read_text(file);
				if ((doc_info->Subject = malloc (strlen (line) + 1)) > 0L)
					strcpy (doc_info->Subject, line);
				break;
			case PDF_INFO_Keywords:
				line = Read_text(file);
				if ((doc_info->Keywords = malloc (strlen (line) + 1)) > 0L)
					strcpy (doc_info->Keywords, line);;
				break;
			case PDF_INFO_Creator:
				line = Read_text(file);
				if ((doc_info->Creator = malloc (strlen (line) + 1)) > 0L)
					strcpy (doc_info->Creator, line);
				break;
			case PDF_INFO_Producer:
				line = Read_text(file);
				if ((doc_info->Producer = malloc (strlen (line) + 1)) > 0L)
					strcpy (doc_info->Producer, line);
				break;
			case PDF_INFO_CreationDate:
				line = Read_text(file);
				strcpy (buf, line);
				Depack_date (buf);
				if ((doc_info->CreationDate = malloc (strlen (line) + 1)) > 0L)
					strcpy (doc_info->CreationDate, line);
				Depack_date(doc_info->CreationDate);
				break;
			case PDF_INFO_ModDate:
				line = Read_text(file);
				if(line)
					strcpy (buf, line);
				Depack_date (buf);
				if ((doc_info->ModDate = malloc (strlen (line) + 1)) > 0L)
					strcpy (doc_info->ModDate, line);
				break;
			}
		}
	}	
	info->file_info->actual_pos = actual_pos;
	GoBack(info);
	return(doc_info);
}