#include	<ext.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>
#include	<math.h>
#include	<x_gem.h>
#include	"mypdf.h"
#include	"mypdf.rh"
#include	"files.h"
#include	"typespdf.h"
#include	"info_pdf.h"
#include	"status.h"
#include	"options.h"
#include	"mp_const.h"
#include	"memdebug.h"
#include	"av_comm.h"
#include	"filters.h"
#include	"cont_pat.h"
#include	"page_con.h"
#include	"windinfo.h"


char *Read_line (struct files_pdf *file);
int Command2ID(struct files_pdf *file, char **table);
unsigned long Read_object_no(struct files_pdf *file);
int read_filter(struct files_pdf *file, char *table);

void Check_ending(char *buffer, unsigned long *pos);

int color_dither_pic (MFDB *image);					/* Eric's routine	*/

void Change_progress_bar (int status, int window, unsigned long value, unsigned long max_value);

int Decompress_stream(struct filter *input, int window);
short FindColorByRGB (short *table, short mode);

BOOLEAN GoToObject(struct PDF_Info *info, unsigned int obj);
BOOLEAN GoBack(struct PDF_Info *info);

unsigned long Get_stream_length(struct PDF_Info *info, int obj_no);

extern WIND_LIST windows[];
extern X_GEM_INFO *x_gem;
extern struct opt options;
extern short sys_pal[];

extern OBJECT *adr_menu, *adr_toolbar, *adr_doc_info, *adr_page_info, *adr_steps, *adr_strings, *adr_popup_menu, *adr_popup_history, *adr_popup_thread, *adr_popup_zoom;


char *pictures_command[]={
		"/Type", 								/* /XObject	*/
		"/Subtype",				 			/* /Image	*/
		"/Name", 								/* /Im1	*/
		"/Width", 							/* 283	*/
		"/Height", 							/* 283	*/
		"/BitsPerComponent", 		/* 8	*/
		"/ColorSpace", 					/* /DeviceRGB	*/
		"/Length", 							/* 9521	*/
		"/Filter", 							/* [/ASCII85Decode /DCTDecode]	*/
		"\rstream",
		NULL};

#define PICTURE_TYPE				1
#define PICTURE_SUBTYPE			2
#define PICTURE_NAME				3
#define PICTURE_WIDTH				4
#define PICTURE_HEIGHT			5
#define PICTURE_BPC					6
#define PICTURE_COLORSPACE	7
#define PICTURE_LENGTH			8
#define PICTURE_FILTER			9
#define PICTURE_STREAM			10

char *colorspace_commands[]={
		"/Indexed", 					
		"/DeviceRGB",
		"/ICCBased",
		"/Length",
		"/Filter",
		"stream",
		NULL};

#define COLORSPACE_INDEXED	1
#define COLORSPACE_RGB			2
#define COLORSPACE_ICCBASED	3
#define COLORSPACE_LENGTH		4
#define COLORSPACE_FILTER		5
#define COLORSPACE_STREAM		6

char *colorspace_commands_ICC[]={
	"/N",
	"/Alternate",
	"/Range",
	"/DeviceGray",
	"/DeviceRGB",
	"/DeviceCMYK",
	"/Length",
	"/Filter",
	NULL};

#define ICC_N						1
#define ICC_ALTERNATE		2
#define ICC_RANGE				3
#define ICC_GRAY				4
#define ICC_RGB					5
#define ICC_CMYK				6
#define ICC_LENGTH			7
#define ICC_FILTER			8



void Save_picture(char *name1, char *data, unsigned long length)
	{
	int fh=0, but=0;
	char name[256]={0};

	strcpy(name, name1);

	if(x_file_select (1, STR (DI_OPEN), "*.JPG", options.paths.default_pdf_dir, name))
		{
		fh = open(name, O_WRONLY|O_TRUNC|O_CREAT);
		if(fh>0)
			{
			write(fh, data, length);
			close(fh);
			}
		}
	}


void FreePicture(struct picture *pic)
	{
	int i=0;

	if(pic)
		{
		while(pic->loaded > i)
			{
			if(pic[i].ColorSpace)
				free(pic[i].ColorSpace);
			if(pic[i].mfdb)
				{
				if(pic[i].mfdb->fd_addr)
					free(pic[i].mfdb->fd_addr);
				free(pic[i].mfdb);
				}
			i++;
			}
		free(pic);
		}
	}


void Load_colorspace(struct PDF_Info *pdf_info, struct picture *pic, int how_many)
	{
	struct	files_pdf	*file = pdf_info->file_info;
	char dummy[10];
	int obj=atoi(&file->buffer[file->actual_pos]), command=1;
	BOOLEAN goback=FALSE;

	how_many = how_many;

	file->actual_pos += (1+strlen(itoa(obj, dummy, 10)));

	if(file->buffer[file->actual_pos]!='<' || file->buffer[file->actual_pos+1]!='<')
		{
		unsigned long length=0;
		char filter[10]={0};

/*		file->actual_pos += strcspn(&file->buffer[file->actual_pos], "]");
*/
		GoToObject(pdf_info, obj);
		goback=TRUE;


		while(command!=0)
			{
			switch((command=Command2ID(file, colorspace_commands)))
				{
				case COLORSPACE_LENGTH:
					length = (int)Read_object_no(file);
					length = Get_stream_length(pdf_info, (int)length);
					break;
				case COLORSPACE_FILTER:
					read_filter(file, filter);
					break;
				case COLORSPACE_INDEXED:
					break;
				case COLORSPACE_RGB:
					{
					int j=0;
					char dummy[10];
					j = atoi(&file->buffer[file->actual_pos]);
					file->actual_pos += (strlen(itoa(j, dummy, 10))+1);

					Load_colorspace(pdf_info, pic->ColorSpace, j);
					break;
					}
				case COLORSPACE_STREAM:
					if(pic->ColorSpace==NULL)
					{
					struct filter input;																						/* Structure for decoding routine	*/
					int ha;

					Check_ending(file->buffer, &file->actual_pos);
					input.input = &file->buffer[file->actual_pos];			/* Initialization									*/
					input.input_len = length;
					input.filter_table = filter;
					input.output = calloc(1, length*5);
					input.output_len = 0;

					if(Decompress_stream(&input, x_find_top_wind())!=0)
						{
						if(pic->ColorSpace==NULL)
							pic->ColorSpace = calloc(1, input.output_len+10);
						memcpy(pic->ColorSpace, input.output, input.output_len);
				/*		ha = open("icc.col", O_CREAT|O_WRONLY);
						write(ha, input.output, input.output_len);
						close(ha);
				*/
						free(input.output);
						}
					break;
					}
/*				case COLORSPACE_ICCBASED:
					Load_colorspace(pdf_info, ColorSpace, how_many);
					break;
*/
				}
			}
		
		}
	else
		pic->ColorSpace = calloc(1, 1000);

	if(goback)
		GoBack(pdf_info);
	}


struct picture *Load_picture(struct PDF_Info *pdf_info, char *name)
	{
	struct	files_pdf	*file = pdf_info->file_info;
	struct picture *output=NULL;
	int keep_going=1, i=0;
	unsigned long prev_pos=file->actual_pos;

	output = calloc(1, sizeof(struct picture));
	if(output==NULL)
		return(NULL);
	strncpy(output->name, name, strcspn(name, " "));

	while(keep_going!=0)
		{
		switch((keep_going=Command2ID(file, pictures_command)))
			{
			case PICTURE_TYPE:						/* Type	*/
				/*		if(Command2ID(file, types_command)!=3)
							printf("Warning: it's not an XObject!!!");	*/
						break;
			case PICTURE_SUBTYPE:						/*	Subtype - must be /Image	*/
						break;
			case PICTURE_NAME:						/*	Name											*/
						i=0;
						file->actual_pos++;
						while(file->buffer[file->actual_pos]!=' ' && file->buffer[file->actual_pos]!='\r' && file->buffer[file->actual_pos]!='\n')
							output->name[i++] = file->buffer[file->actual_pos++];
						break;
			case PICTURE_WIDTH:						/* Width	*/
						output->width = (int)Read_object_no(file);
					break;
			case PICTURE_HEIGHT:						/* height	*/
						output->height = (int)Read_object_no(file);
					break;
			case PICTURE_BPC:						/* BitsPerComponent	*/
						output->BitsPerComponent = (int)Read_object_no(file);
					break;
			case PICTURE_COLORSPACE:						/* ColorSpace	*/
						if(file->buffer[file->actual_pos+1]=='[')
							{
							int i=1;

							while(file->buffer[file->actual_pos+1]!=']' && i!=0 && strncmp(&file->buffer[file->actual_pos], " 0 R ]", strlen(" 0 R ]"))!=0
										&& strncmp(&file->buffer[file->actual_pos], "0 R ]", strlen("0 R ]"))!=0 && strncmp(&file->buffer[file->actual_pos], "0 R]", strlen("0 R]"))!=0)
								{
								i=Command2ID(file, colorspace_commands);
								if(i==COLORSPACE_INDEXED)
									{
									}
								if(i==COLORSPACE_RGB)
									{
									int j=0;
									char dummy[10];
									j = atoi(&file->buffer[file->actual_pos]);
									file->actual_pos += (strlen(itoa(j, dummy, 10))+1);

									Load_colorspace(pdf_info, output, j);
									}
								}
							}
						else
							Load_colorspace(pdf_info, output->ColorSpace, 0);
					break;
			case PICTURE_LENGTH:						/* Length	*/
						output->Length = (int)Read_object_no(file);
						output->Length = Get_stream_length(pdf_info, (int)output->Length);
					break;
			case PICTURE_FILTER:						/* Filter	*/
						read_filter(file, output->filter_table);
					break;
			case PICTURE_STREAM:
					Check_ending(file->buffer, &file->actual_pos);
					output->stream_pos=file->actual_pos;
					break;
			default:
						break;
			}
		}

	file->actual_pos = prev_pos;

	if(output->stream_pos==0)
		{
		while(strncmp(&file->buffer[file->actual_pos], "stream", strlen("stream"))!=0)
			file->actual_pos++;
		file->actual_pos += strlen("stream");
		Check_ending(file->buffer, &file->actual_pos);
		
		output->stream_pos=file->actual_pos;
		}

	return(output);
	}


struct picture *Add_picture(struct picture *dest, struct picture *source)
	{
	int i;
	struct picture *dummy=NULL;

	if(dest==NULL)
		{
		dest = calloc(1, sizeof(struct picture));
		memcpy(dest, source, sizeof(struct picture));
		dest->loaded++;
		}
	else
		{
		dummy = calloc(dest->loaded, sizeof(struct picture));
		memcpy(dummy, dest, dest->loaded*sizeof(struct picture));
		i=dest->loaded;
		source->number = i+1;
		free(dest);

		dest=calloc(i+2, sizeof(struct picture));
		memset(dest, 0, (i+2)*sizeof(struct picture));
		memcpy(dest, dummy, i*sizeof(struct picture));
		memcpy(((char*)dest) + i*sizeof(struct picture), source, sizeof(struct picture));
		dest->loaded++;
		free(dummy);
		}
	if(options.work_mode&LOAD_BITMAP)
		dest[dest->loaded-1].show = TRUE;
	else
		dest[dest->loaded-1].show = FALSE;

	return(dest);
	}


struct picture *Find_picture(struct picture *pictures, char *name)
	{
	int i=0;

	if(pictures==NULL)
		return(NULL);

	while(i<pictures->loaded)
		{
		if(strncmp(pictures[i].name, name, strlen(pictures[i].name))==0)
			return(&pictures[i]);
		i++;
		}
	return(NULL);
	}


void Scale_picture(char *input, char *output, unsigned long width, unsigned long height, double scale)
	{
	double ii=0, jump=0, i=0;

	jump = scale;

	if(output==NULL)
		return;

	for(ii=0 ; i<(width*height); i++, ii+=jump)
		output[ii] = input[i];
	}




/*
	picture:		picture data
	color_map:	color map
	type:				0:	2 colors (black and white)
							1:	grey scale
							2:	256 RGB color = 768 bytes (256x3 bytes)
							3:
	method: 		0 - nearest color
							1 - Floyd-Steinberg
							2 - 
	size:				size of the picture
*/

void dither_picture(int window, char *picture, char *color_map, int type, int method, unsigned long size)
	{
	int i=0, best_color;
	short r, g, b, m, m2=1000, nb_color, *palette;
	unsigned long img_pos=0;
	int *colors=NULL;

	if(color_map==NULL)
		return;

	nb_color = x_gem->work_out[13];
	palette = sys_pal;

	Change_progress_bar (STATUS_PDF_DITHERING, window, 0, 0);
	Change_progress_bar (STATUS_BAR3_UPDATE, window, 0, size);

	if(type==2 && method==0)
		{
		colors = calloc(1, 256*sizeof(int));
		memset(colors, -1, 256*sizeof(int));
		for(img_pos=0; img_pos<size; img_pos++)
			{
			Change_progress_bar (STATUS_BAR3_UPDATE, window, img_pos, size);

			if(colors[picture[img_pos]]==-1)
				{
				r = color_map[picture[img_pos]*3 + 0] * 3.92;
				g = color_map[picture[img_pos]*3 + 1] * 3.92;
				b = color_map[picture[img_pos]*3 + 2] * 3.92;

				m2=1000;
				palette = sys_pal;
				for(i=0; i<nb_color; i++)
					{
					m = (abs (r - *(palette ++)) + abs (g - *(palette ++)) + abs (b - *(palette ++))) / 3;
					if (m < m2)
						{
						best_color = i;
						m2 = m;
						}
					}
				if(best_color!=-1)
					{
					picture[img_pos] = best_color;
					colors[picture[img_pos]] = best_color;
					}
				best_color = -1;
				}
			else
				picture[img_pos] = colors[picture[img_pos]];
			}
		free(colors);
		}
	}


void *chunky8mfdb(char *source, char *output, long size, int planes)
	{
	long i, j, k, b, p, bit;
	long pixel, dest;
	unsigned char *fonty;
	long adres, adres2;
	int pxy[4], pos_x, pos_y;
	unsigned int bity[] = {128, 64, 32, 16, 8, 4, 2, 1};
	unsigned int bity2[] = {32768, 16384, 8192, 4096, 2048, 1024, 512, 256, 128, 64, 32, 16, 8, 4, 2, 1};

	if(output==NULL)
		output = calloc(1, size);

	fonty = (unsigned char*)malloc(size);

	memset( fonty, 0, size);
	memset( output, 0, size);

/*
	pxy[0] = 1000; pxy[1] = 1000; pxy[2] = 1000;
	vs_color(x_gem->ap_id, 255, pxy);

	for(k=0, pos_y=0; pos_y<h; pos_y++)
		{
		for(pos_x=0; pos_x<w; pos_x++, k++)
			{
			vsl_color(app.handle, source[k]);
			pxy[0] = pos_x; pxy[1] = pos_y;
			pxy[2] = pos_x; pxy[3] = pos_y;
			v_pline( app.handle, 2, pxy);
			}
		}
*/
	k=0;


	if(planes==1)												/* Rysunek monochromatyczny								*/
		{
		for(i=0; i<(size); i+=8, k++)			/* Zwiekszanie numeru obrabianego pixela	*/
			{
			for(b=7; b>-1; b--)							/* Zwiekszanie numeru bitu w bajcie docelowym	*/
				{
				j=i+b;
				if(source[j]==1)							/* Czy dany pixel jest ustawiony?							*/
					{
					fonty[k] |= bity2[8+b];					/* Setzt den Bit (bity[k]) in znak[k]	*/
					}
				else
					{
					fonty[k] &= ~(bity2[8+b]);			/* Loescht den Bit (bity[k]) in znak[k]	*/
					}
				}
			}
			return((void*)adres);
		}
	else																/* Rysunek kolorowy					*/
		{
		pos_x = 0; pos_y = 0;
		for(i=0, j=0; i<size; i+=16, j+=8)
			{
			for(bit=8, b=0; bit>-1; bit--, b++)
				{
				for(p=15; p>-1; p--, pos_x++)
					{
					pixel = i + p;
					dest = j + b;
					if(source[pixel]&bity2[8+bit])
						output[dest] |= bity2[p];
					else
						output[dest] &= ~(bity2[p]);
					}
				}
			}
		}
	}



BOOLEAN Chunky_to_mfdb(int window, OB_Picture *picture, char *data, unsigned long max_size)
	{
	struct picture *pic = picture->picture;
	int width1, width=pic->width, height=pic->height, nb_planes=pic->BitsPerComponent, x, y;
	unsigned long img_pos;
	long i, j, k, b, p, bit, dest, planes, pl_max;
	long pixel;
	int pos_x, pos_y, pxy[8]={0};
	short *output=NULL;
	char *line=NULL;
	MFDB ecran={0};
	unsigned int bity2[] = {32768, 16384, 8192, 4096, 2048, 1024, 512, 256, 128, 64, 32, 16, 8, 4, 2, 1, -1};
	struct _pl
		{
		int pl,col;
		}pl[]={	1,	2,
						2,	4,
						4,	16,
						8,	256,
						-1,	-1};

	for(i=0; pl[i].col!=-1; i++)
		{
		if(pl[i].col==x_gem->work_out[13])
			{
			pl_max=pl[i].pl;
			break;
			}
		}

	if(pic->mfdb==NULL)
		pic->mfdb = calloc(1, sizeof(struct _mfdb_));

	if(((width/16)*16)!=width)
		{
		width1 = (1+(width/16))*16;
		}
	else
		width1 = width;
	pic->mfdb->fd_w = width1;
	pic->mfdb->fd_h = height;
	pic->mfdb->fd_wdwidth = pic->mfdb->fd_w/16;
	pic->mfdb->fd_nplanes = nb_planes;
	pic->mfdb->fd_stand = 0;
	pic->mfdb->fd_r1 = pic->mfdb->fd_r2 = pic->mfdb->fd_r3 = 0;

	pic->mfdb->fd_addr = calloc(1, (unsigned long)pic->mfdb->fd_w*(unsigned long)pic->mfdb->fd_h);				/* This will be changed in the near future	*/
	memset(pic->mfdb->fd_addr, 0, (unsigned long)pic->mfdb->fd_w*(unsigned long)pic->mfdb->fd_h);
	output = pic->mfdb->fd_addr;

	pos_x = 0; pos_y = 0;

	line = calloc(1, width1+10);

	pxy[0] = pxy[1] = pxy[4] = pxy[5] = 0;
	pxy[2] = pxy[6] = pic->mfdb->fd_w;
	pxy[3] = pxy[7] = pic->mfdb->fd_h;

	for(j=0, y=0; y<height; y++, j+=width1)
		{
		memset(line, 0, width1);
		memcpy(line, &data[y*width], width);

		chunky8mfdb(line, &output[y*width1], width1, 16);

		pxy[0] = pxy[1] = 0;
		pxy[2] = pxy[6] = pic->mfdb->fd_w;
		pxy[4] = pxy[5] = 0;
		pxy[3] = pxy[7] = pic->mfdb->fd_h;
		vro_cpyfm(x_gem->handle, S_ONLY, (INT16*)&pxy[0], (MFDB*)(pic->mfdb), (MFDB*)&ecran);
		}

	free(line);
/*
	pxy[0] = pxy[1] = pxy[4] = pxy[5] = 0;
	pxy[2] = pxy[6] = pic->mfdb->fd_w;
	pxy[3] = pxy[7] = pic->mfdb->fd_h;
	vro_cpyfm(x_gem->handle, S_ONLY, (INT16*)&pxy[0], (MFDB*)(pic->mfdb), (MFDB*)&ecran);
*/
	}




#define SHOW_PIXEL 					{		pxy[0] = pxy[2] = x+pos_x;	\
							pxy[1] = pxy[3] = y+pos_y;	\
							if(y1>1)	\
								{	\
								prev_line_pos = (unsigned long)(floor(y1)*(double)picture->picture->width);	\
								if(y1<abs(picture->picture->height))	\
									next_line_pos = (unsigned long)(ceil(y1)*(double)picture->picture->width);	\
								image_pos = (double)y1*(double)picture->picture->width;	\
								if((next_line_pos-image_pos)<(image_pos-prev_line_pos))	\
									image_pos = (double)next_line_pos;	\
								else	\
									image_pos = (double)prev_line_pos;	\
								}	\
							image_pos += j;	\
							vsl_color(pdf_info->window_handle, picture1[(unsigned long)image_pos]);	\
							v_pline(pdf_info->window_handle, 2, pxy);		}

void Display_picture(int window, int pos_x, int pos_y, OB_Picture *picture, struct PDF_Info *pdf_info)
	{
	int handle = window;	/*	wind->w_hand;	*/
	INT16 pxy[16]={0}, height_org, width_org, height_new, width_new;
	char *input_s = picture->stream;
	double scale1=0, scale2=0;
	MFDB picture_mfdb;

	while(*input_s=='\r' || *input_s=='\n')
		input_s++;

	if(picture->picture==NULL)
		return;

	height_org = (int)(pdf_info->scale*(double)picture->picture->height);
	width_org = (int)(pdf_info->scale*(double)picture->picture->width);

	width_new = (int)(pdf_info->scale*(double)picture->a);
	height_new = (int)(pdf_info->scale*(double)picture->d);

	pxy[0] = pos_x + (int)(pdf_info->scale*(double)picture->e);												/*		1,1	*/
	pxy[1] = pos_y + pdf_info->page_h - (int)(pdf_info->scale*(double)picture->f);	

	pxy[2] = pos_x + (int)(pdf_info->scale*(double)picture->e) + width_new;
	pxy[3] = pos_y + pdf_info->page_h - (int)(pdf_info->scale*(double)picture->f) - height_new;

	pos_x = pxy[0];
	pos_y = pxy[1];

	picture->picture->new_position.pos_x = pos_x;
	picture->picture->new_position.pos_y = pos_y;


/* The picture will NOT be displayed if:
		the picture is off AND showing of bitmap is off OR
		if the picture is off	*/
	if((!(options.work_mode&LOAD_BITMAP) && picture->picture->show!=TRUE) || picture->picture->show!=TRUE)				/* Do we want to display a picture?		*/
		{																					/* NO																	*/
		vsf_style(handle, 3);
		vsf_color(handle, BLACK);
		vsf_interior( handle, 2);
		v_bar(handle, pxy);
		vst_color(handle, BLUE);
		v_gtext(handle, pxy[0], pxy[1]-height_new/2, "Picture name");
		if(picture!=NULL)
			v_gtext(handle, pxy[0], pxy[1]+15-height_new/2, picture->picture->name);
		vst_color(handle, BLACK);
		}

/* The picture will be displayed if:
		there is a picture AND
		the showing of bitmap is on OR the picture is on	*/
	else if(picture->picture && (options.work_mode&LOAD_BITMAP || picture->picture->show==TRUE))				/* Do we want to display a picture and is there any picture?		*/
		{																																/* YES																													*/
		struct files_pdf *file = pdf_info->file_info;
		struct filter input;																						/* Structure for decoding routine	*/
		unsigned long x=0,y=0, prev_line_pos=0, next_line_pos=0;
		double j, ii=((double)width_org/(double)width_new), y1=0, image_pos=0;
		char *picture1;
		short *color_space=(short*)picture->picture->ColorSpace;

		input.input = &file->buffer[picture->picture->stream_pos];			/* Initialization									*/
		input.input_len = picture->picture->Length;
		input.filter_table = picture->picture->filter_table;
		input.output_len = 0;

		if(input.filter_table!=NULL)																		/* Is there something to decode?	*/
			{
			if(Decompress_stream(&input, x_find_top_wind())!=0)
				{				/* This part HAVE to be changed to	*/
				scale1 = fabs((double)picture->picture->width/(double)picture->a);
				scale2 = fabs((double)picture->picture->height/(double)picture->d);
				if(scale1>scale2)
					scale1 = scale2;
				scale2 = 1/pdf_info->scale;
				ii = scale1 * scale2;

/*
				Scale_picture(input.output, picture1, picture->picture->width, picture->picture->height, pdf_info->scale);
*/
/*
				picture_mfdb.fd_addr = input.output;
				picture_mfdb.fd_w = picture->picture->width;
				picture_mfdb.fd_h = picture->picture->height;
				picture_mfdb.fd_wdwidth = picture_mfdb.fd_w/16;
				color_dither_pic (&picture_mfdb);
					{
					MFDB ecran={0};
					MFDB pic={0};
					memcpy(&pic, &picture_mfdb, sizeof(MFDB));
					pic.fd_addr = calloc(1, 800*608);
					pxy[0] = pxy[1] = pxy[4] = pxy[5] = 0;
					pxy[2] = pxy[6] = picture_mfdb.fd_w;
					pxy[3] = pxy[7] = picture_mfdb.fd_h;
					vr_trnfm(x_gem->handle, &picture_mfdb, &pic);
					vro_cpyfm(x_gem->handle, S_ONLY, pxy, &pic, &ecran);
					free(pic.fd_addr);
					}
*/

				dither_picture(pdf_info->window_number, (char *)input.output, (char*)color_space, 2, 0, (unsigned long)input.output_len);


				if(picture->picture->mfdb==NULL)
					{
					picture1=input.output;

/*					Chunky_to_mfdb(pdf_info->window_number, picture, picture1, input.output_len);
*/
					if(picture->d>0)
						{
						pos_y -= height_new;
						for(image_pos=0, j=0, y=0, y1=0; y<abs(height_new); y++, y1+=ii)
							{
							for(j=0, x=0; x<width_new && (unsigned long)image_pos<input.output_len; x++, j+=ii)
								SHOW_PIXEL
							}
						}
					else
						{
						for(image_pos=0, j=0, y1=0, y=abs(height_new); y>0; y--, y1+=ii)
							{
							for(j=0, x=0; x<width_new && (unsigned long)image_pos<input.output_len; x++, j+=ii)
								SHOW_PIXEL
							}
						}
					}
				else			/* There is a MFDB already	*/
					{
					}
				graf_mouse (ARROW, 0L);
				}
			else
				{																					/* Unknown compression method of picture	*/
				vsf_style(handle, 3);
				vsf_color(handle, BLACK);
				vsf_interior( handle, 2);
				v_bar(handle, pxy);
				vst_color(handle, BLUE);
				v_gtext(handle, pxy[0], pxy[1]-height_new/2, "Picture name");
				if(picture!=NULL)
					v_gtext(handle, pxy[0], pxy[1]+15-height_new/2, picture->picture->name);
				vst_color(handle, BLACK);
				}
			}
		if(input.output)
			free(input.output);
		}	

	picture->picture->new_position.pos_x1 = picture->picture->new_position.pos_x + width_new;
	picture->picture->new_position.pos_y1 = picture->picture->new_position.pos_y - height_new;
	picture->picture->new_position.width = width_new;
	picture->picture->new_position.height = height_new;

/*
	pxy[0] = picture->picture->new_position.pos_x;
	pxy[1] = picture->picture->new_position.pos_y;
	pxy[2] = picture->picture->new_position.pos_x1;
	pxy[3] = picture->picture->new_position.pos_y1;
	v_rbox(handle, pxy);
*/
	}



void Check_pictures(int event)
	{
	short window, i;
	WIND_LIST *wind;
	WIND_INFO *wind_info;
	struct PDF_Info *pdf_info=NULL;
	struct page_contents *page=NULL;
	struct picture *pic=NULL;

	event=event;
	if((window = x_gem->event_wind)==-1)
		return;
	wind = &x_gem->wind[window];
	wind_info = (WIND_INFO *)wind->w_user1;

	if(wind_info==NULL)
		return;
	pdf_info = wind_info->pdf_info;
	if(pdf_info==NULL)
		return;

	page = (struct page_contents *)(pdf_info->pages_contents[0].adress);
	pic = page->resource->pictures;

	if(pic==NULL)
		return;
	pdf_info->over_picture = FALSE;
	for(i=pic->loaded; i>=0; i--)
		{
		if((x_gem->mx>pic[i].new_position.pos_x && x_gem->mx<pic[i].new_position.pos_x1) ||
				(x_gem->mx>pic[i].new_position.pos_x1 && x_gem->mx<pic[i].new_position.pos_x))
			{
			if((x_gem->my>pic[i].new_position.pos_y && x_gem->my<pic[i].new_position.pos_y1) ||
				(x_gem->my>pic[i].new_position.pos_y1 && x_gem->my<pic[i].new_position.pos_y))
				{
				pdf_info->over_picture = TRUE;
				pdf_info->over_picture_no = i;
				break;
				}
			}
		}
	}