#include	<ext.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>
#include	<x_gem.h>
#include	"mypdf.h"
#include	"mypdf.rh"
#include	"files.h"
#include	"typespdf.h"
#include	"info_pdf.h"
#include	"status.h"
#include	"options.h"
#include	"mp_const.h"
#include	"memdebug.h"
#include	"av_comm.h"
#include	"cont_pat.h"
#include	"windinfo.h"
#include	"FILTERS.H"


int Command2ID(struct files_pdf *, char **);
unsigned long Read_object_no(struct files_pdf *);
int read_object_no(int );
char *Read_last_line(struct files_pdf *);
char *Read_line(struct files_pdf *);
char *Read_prev_line(struct files_pdf *);
char *read_prev_line(int );
char *Read_text(struct files_pdf *);

struct Rectangle *Read_rectangle(struct files_pdf *);

void Load_colorspace(struct PDF_Info *pdf_info, char *ColorSpace, int how_many);

int read_filter(struct files_pdf *file, char *table);

long find_object_number (struct file_position *, int , unsigned int );
BOOLEAN load_objects(struct files_pdf);
BOOLEAN Load_objects(struct PDF_Info *,int);

void Depack_date(char *);

BOOLEAN GoToObject(struct PDF_Info *, unsigned int );
BOOLEAN GoBack(struct PDF_Info *);

static signed long read_number(char *stream, unsigned long *len);

char *thumbnail_commands[]={
	"/Width",
	"/Height",
	"/ColorSpace",
	"/BitsPerComponent",
	"/Length",
	"stream",
	"/Filter",
	"endstream",
	NULL
	};

extern char *colorspace_commands[];
#define COLORSPACE_INDEXED	1
#define COLORSPACE_RGB			2
#define COLORSPACE_ICCBASED	3
#define COLORSPACE_LENGTH		4
#define COLORSPACE_FILTER		5
#define COLORSPACE_STREAM		6


unsigned long Get_stream_length(struct PDF_Info *info, int obj_no)
	{
	struct files_pdf *file = info->file_info;
	unsigned long output=0;;

	if(strncmp(&file->buffer[file->actual_pos], " 0 R", strlen(" 0 R"))!=0 && strncmp(&file->buffer[file->actual_pos], "0 R", strlen("0 R"))!=0)
		return(obj_no);

	GoToObject(info, (unsigned int)obj_no);

	while(file->buffer[file->actual_pos]!='\r')
		file->actual_pos++;

	if(file->buffer[file->actual_pos]=='\r' || file->buffer[file->actual_pos]=='\n')
		file->actual_pos++;
	if(file->buffer[file->actual_pos]=='\r' || file->buffer[file->actual_pos]=='\n')
		file->actual_pos++;

	output = atol(&file->buffer[file->actual_pos]);

	GoBack(info);

	return(output);
	}


struct ThumbNail *read_thumbnails(struct PDF_Info *info, int obj_no, struct ThumbNail *thumb_in)
	{
	struct files_pdf *file = info->file_info;
	char *line=NULL;
	struct ThumbNail *thumb=NULL;
	BOOLEAN keep_going=TRUE;

	GoToObject(info, (unsigned int)obj_no);

	thumb = calloc (1, sizeof (struct ThumbNail));

	if(thumb!=NULL)
		{
		line = Read_line(file);

		thumb->number = ++(info->pages->how_many_thumbnails);

		while(keep_going)
			{
			if(line && strstr(line, "endstream")==NULL)
				{
				switch((keep_going=Command2ID(file, thumbnail_commands)))
					{
					case THUMBNAIL_WIDTH:
							thumb->Width = (int)Read_object_no(file);
							break;
					case THUMBNAIL_HEIGHT:
							thumb->Height = (int)Read_object_no(file);
							break;
					case THUMBNAIL_COLOR:
						if(file->buffer[file->actual_pos+1]=='[')
							{
							int i=1;

							while(file->buffer[file->actual_pos+1]!=']' && i!=0 && strncmp(&file->buffer[file->actual_pos], " 0 R ]", strlen(" 0 R ]"))!=0
										&& strncmp(&file->buffer[file->actual_pos], "0 R ]", strlen("0 R ]"))!=0 && strncmp(&file->buffer[file->actual_pos], "0 R]", strlen("0 R]"))!=0)
								{
								i=Command2ID(file, colorspace_commands);
								if(i==COLORSPACE_INDEXED)
									{
									}
								if(i==COLORSPACE_RGB)
									{
									int j=0;
									char dummy[10];
									j = atoi(&file->buffer[file->actual_pos]);
									file->actual_pos += (strlen(itoa(j, dummy, 10))+1);

									Load_colorspace(info, thumb->ColorSpace, j);
									}
								}
							}
						else
							Load_colorspace(info, thumb->ColorSpace, 0);

							break;
					case THUMBNAIL_BITS:
							thumb->BitsPerComponent = (int)Read_object_no(file);
							break;
					case THUMBNAIL_LENGHT:
							thumb->Lenght = Read_object_no(file);
							thumb->Lenght = Get_stream_length(info, (int)thumb->Lenght);
							break;
					case THUMBNAIL_FILTER:
							 read_filter(file, &thumb->filter[0]);
							break;
					case THUMBNAIL_STREAM:
							if(thumb->stream==NULL)
								{
								thumb->stream = &file->buffer[file->actual_pos];
								if(thumb->stream[0]=='\r' || thumb->stream[0]=='\n')
									thumb->stream++;
								if(thumb->stream[0]=='\r' || thumb->stream[0]=='\n')
									thumb->stream++;
								}
							break;
					default:
								;
								break;
					}
				}
			}

		file->actual_pos += thumb->Lenght;

		GoBack(info);

		if(info->thumb==NULL)
			{
			info->thumb = calloc (1, sizeof (struct ThumbNail));
			if(info->thumb)
				memcpy(info->thumb, thumb, sizeof (struct ThumbNail));
			}

		if(thumb_in)
			memcpy(thumb_in, thumb, sizeof (struct ThumbNail));

		return(thumb);
		}

	GoBack(info);
	return(NULL);
}


extern X_GEM_INFO *x_gem;
int Decompress_stream(struct filter *input, int window);
void *chunky8mfdb(char *source, long size, int planes);

void Display_thumbnails(WIND_INFO *wind_info, short posx, short posy, short miny, short maxy)
	{
	struct PDF_Info *info = wind_info->pdf_info;
	int page_nr=0, prev_h=0;
	char *picture=NULL;
	struct ThumbNail *thumb=&info->pages->thumb;
	INT16 handle = x_find_top_wind(), pxy[8]={0};
	WIND_LIST *wind=NULL;
	OBJECT *adr=NULL;
	struct filter input;
	MFDB ecran={0}, *picture_mfdb;

	wind = &x_gem->wind[x_find_top_wind()];
	adr = wind->w_dial.d_addr;

	posy -= 15;
	posx += 10;

	pxy[0] = posx-5;	pxy[1] = posy-5;
	pxy[2] = posx + adr[DTREE_TB].ob_width;	pxy[3] = miny + adr[DTREE_TB].ob_height;
	vs_clip(info->window_handle, 1, &pxy[0]);


	for(page_nr=0; page_nr<info->pages->max_to_load; page_nr++)
		{
		thumb = &(info->pages[page_nr].thumb);

		if(thumb->stream)			/* Let`s depack the thumbnail	*/
			{
			input.input = thumb->stream;
			input.input_len = thumb->Lenght;
			input.filter_table = thumb->filter;
			input.output = calloc(1, thumb->Lenght*5);
			input.output_len = 0;

			if(input.filter_table!=NULL)
				Decompress_stream(&input, x_find_top_wind());
/*
			picture = chunky8mfdb(input.output, input.output_len, thumb->BitsPerComponent);

			picture_mfdb = calloc(1, sizeof(MFDB));
			picture_mfdb->fd_addr = picture;               /* Zeiger auf den Beginn des*/
      picture_mfdb->fd_w = thumb->Width;                   /* Blockbreite in Pixeln    */
      picture_mfdb->fd_h = thumb->Height;                   /* Hhe des Blocks in Pixeln*/
      picture_mfdb->fd_wdwidth = picture_mfdb->fd_w/16;             /* Blockbreite in Integern  */
      picture_mfdb->fd_stand = 0;               /* 0 = gerteabhngiges Format	*/
      picture_mfdb->fd_nplanes = 8;             /* Anzahl der Farbebenen    */
      picture_mfdb->fd_r1 = picture_mfdb->fd_r2 = picture_mfdb->fd_r3 = 0;
			pxy[0] = pxy[1] = 0;
			pxy[2] = thumb->Width;
			pxy[3] = thumb->Height;
			vro_cpyfm(x_gem->ap_id, S_ONLY, pxy, &ecran, picture_mfdb);
			free(picture_mfdb);
*/
			}

		posy += (prev_h + 20);
		prev_h = thumb->Height;

		pxy[0] = posx + 2;
		pxy[1] = posy + 2;
		pxy[2] = posx + thumb->Width + 2;
		pxy[3] = posy + thumb->Height + 2;
		vsf_color(info->window_handle, LBLACK);
		v_bar(info->window_handle, &pxy[0]);

		pxy[0] = posx - 1;
		pxy[1] = posy - 1;
		pxy[2] = posx + thumb->Width  + 1;
		pxy[3] = posy + thumb->Height + 1;
		vsf_color(info->window_handle, BLACK);
		vsf_perimeter(info->window_handle, 1);
		v_bar(info->window_handle, &pxy[0]);

		pxy[0] = posx;
		pxy[1] = posy;
		pxy[2] = posx + thumb->Width - 1;
		pxy[3] = posy + thumb->Height - 1;
		vsf_color(info->window_handle, WHITE);
		v_bar(info->window_handle, &pxy[0]);


			{				/* This part HAVE to be changed to	*/
			int x,y,j;

			vs_clip(info->window_handle, 0, &pxy[0]);
			for(j=0, y=0; y<thumb->Height; y++)
				{
				for(x=0; x<thumb->Width; x++, j++)
					{
					pxy[0] = x+posx;	pxy[1] = y+posy;
					pxy[2] = x+posx;	pxy[3] = y+posy;
					vsl_color(info->window_handle, input.output[j]/16);
					v_pline(info->window_handle, 2, pxy);
					}
				}
			}
		}

	vs_clip(info->window_handle, 0, &pxy[0]);
	}