#define LOAD_TRAILER		1			/* Trailer					*/
#define LOAD_ENCRYPT		2			/* Encryption				*/
#define LOAD_ROOTOBJ		4			/* Root object			*/
#define LOAD_OUTLINE		8			/* Outline					*/
#define LOAD_THREADS		16		/* Article threads	*/
#define LOAD_PAGETRE		32		/* Page tree				*/
#define LOAD_THUMBNAIL	64		/* Load thumbnails	*/
#define LOAD_TEXT				128		/* Load text				*/
#define LOAD_VECTOR			256		/* Load vector gfx	*/
#define LOAD_BITMAP			512		/* Load bitmaps			*/
#define LOAD_ANTIALIAS	1024	/* DO anitaliasing	*/


#define LOG_NO						0
#define LOG_YES_DEL				1
#define LOG_YES_ADD				2
#define LOG_YES_FOL				3
#define LOG_YES_ORI				4

#define HISTORY_ZOOM					1
#define HISTORY_SLIDER				2
#define HISTORY_PAGES					4



#define ACT_VERS	"0013"
#define MIN_VERS	"0013"


typedef struct pat
		{
		char *app_dir;						/* MyPDF directory				*/
		char *default_pdf_dir;		/* Default PDF directory	*/
		char *fonts;							/* Font directory					*/
		char *logs;								/* The log directory			*/
		char *cache;							/* Cache path							*/
		};


extern char *last_10_files[10];

#define PROT_DHST					1
#define PROT_AVVA					2
#define PROT_D_D					4
#define PROT_GEMSCRIPT		8
#define PROT_OLGA					16

typedef struct sys
		{
		int system;
		int protocols;						/* Available protocols:
																	1: DHST								*/
		};

typedef struct debug
		{
		BOOLEAN bar, steps, memory;
		};


typedef struct opt
	{
	unsigned long max_mem;			/* Maximum amount of memory for a file	*/
	unsigned long per_mem;			/* Percentage usage of memory. It means thay MyPDF will use per_mem percent of memory but always less then max_mem	*/
	unsigned long ava_mem;			/* Maximum amount of memory available at the start of MyPDF	*/
	BOOLEAN max_memory;					/*	TRUE - the use of max memory
																	FALSE - the use of maximum of % of available memory	*/
	char history;								/* What should be stored:
																	1 - zoom operations
																	2 - slider operations
																	4 - page changing	*/
	int date_type;							/* How the date should be show:
																0: dd.mm.yyyy
																1: dd.mm.yy
																2: yyyy.mm.dd
																3: yy.mm.dd
																4: mm.dd.yyyy
																5: mm.dd.yy
																6: dd. month name. yyyy
																7: dd. month name. yy
																8: yyyy. month name. dd
																9. yy. month name. dd
																10. month name. dd.yyyy
																11. month name. dd.yy					*/
	int language;								/* Language of MyPDF:
																0: english
																1: french
																2: german
																3: polish
																4: swedish
																5: spanish
																6: finish (suomi??)
																7: tschechisch
																8: italian
																9: holandish
																10: .............
															*/
	int work_mode;
	char usu;										/* User Space Units:
																0 - inches
																1 - cm
																2 - milimeters
																3 - points				(72 points = 1 inch)
															*/
	int log;										/* Should some operations be logged into a specified file?
																0: no
																1: yes, to the pdflog.log - always delete old file
																2: yes, to the pdflog.log - add log to the old file
																3: yes, to the xxxxxx.log - in the log folder (where xxxxxx is the file name)
																4: yes, to the xxxxxx.log - in the directory where the file is located (where xxxxxx is the file name)
															*/
	char dithering_method;			/*
																0: nearest color
																1: Floyd-Steinberg
																2: System colors
																3: Grey scale (linear)
																4: Grey scale (Gamma-Korrektur 0.4)
																*/
	BOOLEAN	autosave;						/* Autosave options	*/
	BOOLEAN step_by_step;				/* Used only in debug mode when before loading any of the elements user has to click any key	*/
	BOOLEAN bubble_help;				/* Should I display the BubbleHELP?											*/
	BOOLEAN use_cache;					/* Should MyPDF use cache on a disc to store the page for future use?	*/
	int bubble_time;						/* -1 = show it after the users hits right button
																	other value means time in [ms]											*/
	int last_files;							/* How many 'last' files are in memory									*/
	struct debug show_debug;
	struct pat paths;						/* Paths to different things important for the program	*/
	struct sys system;					/* Informations about the system												*/
	};