#include	<ext.h>
#include	<stdarg.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>
#include	<math.h>
#include	<x_gem.h>
#include	"mypdf.h"
#include	"mypdf.rh"
#include	"files.h"
#include	"typespdf.h"
#include	"info_pdf.h"
#include	"status.h"
#include	"options.h"
#include	"mp_const.h"
#include	"memdebug.h"
#include	"av_comm.h"
#include	"filters.h"
#include	"graf_sta.h"
#include	"cont_pat.h"
#include	"text_st.h"
#include	"page_con.h"
#include	"windinfo.h"

extern struct opt options;


BOOLEAN Load_cache(WIND_INFO *wind_info)
	{
	struct PDF_Info *pdf_info = wind_info->pdf_info;
	PDF_OBJECT *pdf_object=NULL, *temp=NULL;
	char *file_name=calloc(1, strlen(pdf_info->file_info->name));
	char path[1000]={0};
	int handle=0;
	unsigned long length=0, len2;

	return(FALSE);

	strcpy(file_name, pdf_info->file_info->name);

	if(options.use_cache==FALSE)
		return(FALSE);

	x_cut_filename(file_name);

	sprintf(path, "%s%s\\%d.pag", options.paths.cache, file_name, pdf_info->page_no);

	handle = open(path, O_RDONLY);
	if(handle>0)
		{
		pdf_object = wind_info->pdf_object;
		if(pdf_object==NULL)
			{
			temp = pdf_object = calloc(1, sizeof(PDF_OBJECT));
			wind_info->pdf_object = pdf_object;
			}
		else
			{
			temp = pdf_object = calloc(1, sizeof(PDF_OBJECT));
			wind_info->pdf_object->next = pdf_object;
			}
		length=filelength(handle);

		while(length>Fseek(0, handle, 1))
			{
			read(handle, &pdf_object->type, 2);
			switch(pdf_object->type)
				{
				case TEXT_OPERATORS+4:								/* Tf */
					read(handle, &pdf_object->spec.Tf, sizeof(OB_Tf));
					break;
				case TEXT_OPERATORS+8:								/* Tj */
				case TEXT_OPERATORS+9:								/* TJ */
					read(handle, &pdf_object->spec.Tj, sizeof(OB_Tj));
					read(handle, &pdf_object->spec.Tj.len, 4);
					if(pdf_object->spec.Tj.len)
						{
						pdf_object->spec.Tj.text = calloc(1, pdf_object->spec.Tj.len*2);
						read(handle, pdf_object->spec.Tj.text, pdf_object->spec.Tj.len*2);
						}
					read(handle, &len2, 4);
					if(len2>0)
						{
						pdf_object->spec.Tj.dis_x = calloc(1, len2*4);
						read(handle, pdf_object->spec.Tj.dis_x, pdf_object->spec.Tj.len*4);
						}
					break;
				case PATH_PAINTING_OPERATOR+0:						/* PAINT THE PATH CONSTRUCTION	*/
				case PATH_PAINTING_OPERATOR+1:
				case PATH_PAINTING_OPERATOR+2:
				case PATH_PAINTING_OPERATOR+3:
				case PATH_PAINTING_OPERATOR+4:
				case PATH_PAINTING_OPERATOR+5:
				case PATH_PAINTING_OPERATOR+6:
				case PATH_PAINTING_OPERATOR+7:
				case PATH_PAINTING_OPERATOR+8:
				case PATH_PAINTING_OPERATOR+9:
					{
					int i=0;
					
					read(handle, &pdf_object->spec.path_construction.path, sizeof(struct graphical_state));

					while(i<pdf_object->spec.path_construction.done_objects)
						read(handle, &pdf_object->spec.path_construction.objects[i++], sizeof(struct path_objects));

					write(handle, &pdf_object->spec.path_construction.done_objects, 2);
					}
					break;
				case OBJECT_POSITIONING_OPERATOR:		/* Do	*/
					read(handle, pdf_object->spec.Pic.picture, sizeof(struct picture));
/*
					read(handle, pdf_object->spec.Pic.picture->ColorSpace,	);
					read(handle, pdf_object->spec.Pic.picture->mfdb,	);
*/								
					read(handle, &pdf_object->spec.Pic.a, sizeof(pdf_object->spec.Pic.a));
					read(handle, &pdf_object->spec.Pic.b, sizeof(pdf_object->spec.Pic.b));
					read(handle, &pdf_object->spec.Pic.c, sizeof(pdf_object->spec.Pic.c));
					read(handle, &pdf_object->spec.Pic.d, sizeof(pdf_object->spec.Pic.d));
					read(handle, &pdf_object->spec.Pic.e, sizeof(pdf_object->spec.Pic.e));
					read(handle, &pdf_object->spec.Pic.f, sizeof(pdf_object->spec.Pic.f));
					read(handle, &pdf_object->spec.Pic.picture->Length, 4);
					if(pdf_object->spec.Pic.picture->Length>0)
						{
						pdf_object->spec.Pic.stream = calloc(1, pdf_object->spec.Pic.picture->Length);
						read(handle, pdf_object->spec.Pic.stream, pdf_object->spec.Pic.picture->Length);
						}
				break;
				}
			if(length>Fseek(0, handle, 1))
				{
				pdf_object->next = calloc(1, sizeof(PDF_OBJECT));
				temp = pdf_object;
				pdf_object = pdf_object->next;
				pdf_object->next = NULL;
				}
			}

		close(handle);
		}
	else
		return(FALSE);

	free(file_name);
	return(TRUE);
	}


BOOLEAN Save_cache(WIND_INFO *wind_info)
	{
	struct PDF_Info *pdf_info = wind_info->pdf_info;
	char *file_name=calloc(1, strlen(pdf_info->file_info->name));
	PDF_OBJECT *pdf_object=wind_info->pdf_object;
	char path[1000]={0};
	int handle;

	return(FALSE);

	strcpy(file_name, pdf_info->file_info->name);

	if(options.use_cache==FALSE)
		return(TRUE);


	if(pdf_object==FALSE)
		{
		free(file_name);
		return(-1);
		}

	x_cut_filename(file_name);
	sprintf(path, "%s%s", options.paths.cache, file_name);
	{
	char path2[256]={0};
	Dgetpath(path2, Dgetdrv());
	if(Dsetpath(path)<0)
		Dcreate(path);
	Dsetpath(path2);
	}
	sprintf(path, "%s%s\\%d.pag", options.paths.cache, file_name, pdf_info->page_no);
	if((handle=open(path, O_WRONLY))<0)
		{
		handle=open(path, O_WRONLY|O_CREAT);
		while(pdf_object)
			{
			write(handle, &pdf_object->type, 2);
			switch(pdf_object->type)
				{
				case TEXT_OPERATORS+4:								/* Tf */
					write(handle, &pdf_object->spec.Tf, sizeof(OB_Tf));
					break;
				case TEXT_OPERATORS+8:								/* Tj */
				case TEXT_OPERATORS+9:								/* TJ */
					write(handle, &pdf_object->spec.Tj, sizeof(OB_Tj));
					write(handle, &pdf_object->spec.Tj.len, 4);
					write(handle, pdf_object->spec.Tj.text, pdf_object->spec.Tj.len*2);
					if(pdf_object->spec.Tj.dis_x==NULL)
						write(handle, pdf_object->spec.Tj.dis_x, 4);
					else
						{
						write(handle, &pdf_object->spec.Tj.len, 4);
						write(handle, pdf_object->spec.Tj.dis_x, pdf_object->spec.Tj.len*4);
						}
					break;
				case PATH_PAINTING_OPERATOR+0:						/* PAINT THE PATH CONSTRUCTION	*/
				case PATH_PAINTING_OPERATOR+1:
				case PATH_PAINTING_OPERATOR+2:
				case PATH_PAINTING_OPERATOR+3:
				case PATH_PAINTING_OPERATOR+4:
				case PATH_PAINTING_OPERATOR+5:
				case PATH_PAINTING_OPERATOR+6:
				case PATH_PAINTING_OPERATOR+7:
				case PATH_PAINTING_OPERATOR+8:
				case PATH_PAINTING_OPERATOR+9:
					{
					int i=0;
					
					write(handle, &pdf_object->spec.path_construction.path, sizeof(struct graphical_state));

					while(i<pdf_object->spec.path_construction.done_objects)
						write(handle, &pdf_object->spec.path_construction.objects[i++], sizeof(struct path_objects));

					write(handle, &pdf_object->spec.path_construction.done_objects, 2);
					}
					break;
				case OBJECT_POSITIONING_OPERATOR:		/* Do	*/
					write(handle, pdf_object->spec.Pic.picture, sizeof(struct picture));
/*
					write(handle, pdf_object->spec.Pic.picture->ColorSpace,	);
					write(handle, pdf_object->spec.Pic.picture->mfdb,	);
*/								
					write(handle, &pdf_object->spec.Pic.a, sizeof(pdf_object->spec.Pic.a));
					write(handle, &pdf_object->spec.Pic.b, sizeof(pdf_object->spec.Pic.b));
					write(handle, &pdf_object->spec.Pic.c, sizeof(pdf_object->spec.Pic.c));
					write(handle, &pdf_object->spec.Pic.d, sizeof(pdf_object->spec.Pic.d));
					write(handle, &pdf_object->spec.Pic.e, sizeof(pdf_object->spec.Pic.e));
					write(handle, &pdf_object->spec.Pic.f, sizeof(pdf_object->spec.Pic.f));
					write(handle, &pdf_object->spec.Pic.picture->Length, 4);
					write(handle, pdf_object->spec.Pic.stream, pdf_object->spec.Pic.picture->Length);
				break;
				}
			pdf_object = pdf_object->next;
			}
		}
	close(handle);
	free(file_name);
	return(TRUE);
	}