#include	<stdio.h>
#include	<string.h>
#include	<portab.h>
#include	<stdlib.h>
#include	<x_gem.h>


#ifndef NULL
	#define NULL        ((void *)0L)
#endif

#ifndef	DHST_ADD
	#define	DHST_ADD			0xdadd
#endif

#if !defined (DHST_ACK)
#define	DHST_ACK			0xdade
#endif

#ifndef	DHSTINFO
typedef struct
	{
	char		*appname,
				*apppath,
				*docname,
				*docpath;
} DHSTINFO;
#endif

/* Definitions */

ULONG DHST_ServerId( VOID );

 
ULONG	DHST_write( ULONG ap_id, ULONG count, UBYTE *appname, UBYTE *apppath,
                                            UBYTE *docname, UBYTE *docpath);

ULONG	DHST_init( void );
 
ULONG DHST_exit( ULONG ap_id, ULONG count );

ULONG DHST_evnt_ack( ULONG ap_id, ULONG count, ULONG msg0, ULONG msg3, ULONG msg4 );


static long cookieptr(void) { 
	return *((long *)0x5a0); 
}

int get_cookie (long cookie, long *p_value) {
	long *cookiejar = (long *)Supexec (cookieptr);
	if (!cookiejar) return 0;

	do {
		if (cookiejar[0] == cookie) {
			if (p_value) *p_value = cookiejar[1];
			return 1;
		}
		cookiejar += 2;
	} while (cookiejar[-2]);

	return 0;
}

ULONG DHST_ServerId( VOID )
{
	long cookieval;
	int noerror;
	
	noerror = get_cookie ('DHST', &cookieval);
	
	if( noerror!=0 )
		return( cookieval );
	else 
		return( 0L );
}

ULONG	DHST_write( ULONG ap_id, ULONG count, UBYTE *appname, UBYTE *apppath,
                                            UBYTE *docname, UBYTE *docpath)
{
	UWORD	msg[8];
	UWORD	server;
	DHSTINFO	*datablock=NULL;
	
	if( (server = (UWORD)DHST_ServerId())>0 )
	{	
		datablock = calloc(1, sizeof( DHSTINFO )); 
		datablock->appname = calloc(1, strlen( appname ) + 1 );
		datablock->apppath = calloc(1, strlen( apppath ) + strlen("mypdf.app") + 5 );
		datablock->docname = calloc(1, strlen( docname ) + 1 );
		datablock->docpath = calloc(1, strlen( docpath ) + 1 );

		strcpy( datablock->appname, appname );
		strcpy( datablock->apppath, apppath );
		if(strstr(strlwr(apppath), "mypdf.app")==NULL)
			{
			strcat(datablock->apppath, "mypdf.app");
/*			printf("%s\n", datablock->apppath);	*/
			}
		strncpy( datablock->docname, docname, 20 );
		strcpy( datablock->docpath, docpath );

		if(strlen(docname)>20)
			{
			datablock->docname[19]='.';
			datablock->docname[18]='.';
			datablock->docname[17]='.';
			}

		msg[0] = DHST_ADD;
		msg[1] = (UWORD)ap_id;
		msg[2] = 0;
		*(DHSTINFO **)(msg + 3) = datablock;
		msg[5] = 0;
		msg[6] = 0;
		msg[7] = 0;
		appl_write( server, 16, msg );  /* Envoi du message */
	}
	
	return( count );
}


ULONG	DHST_init( void )
{
	
	if( DHST_ServerId() )
		return( 1 );
	else
		return( 0 );
}